<?php
namespace Teknisa\FIN\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO\Response\Error;
use Teknisa\FIN\Services\Rec57001RelatorioConciliacaoCaixaService;

class Rec57001RelatorioConciliacaoCaixaController  {
    protected $reportService;
    protected $dataSourceManager;
    protected $nrorg;
    protected $relatorioConciliacaoCaixaService;

    public function __construct(ReportService $reportService,$dataSourceManager, $environment, Rec57001RelatorioConciliacaoCaixaService $relatorioConciliacaoCaixaService) {
        $this->reportService       = $reportService;
        $this->dataSourceManager   = $dataSourceManager;
        $this->nrorg = $environment->getNrorgTrab();
        $this->Rec57001RelatorioConciliacaoCaixaService = $relatorioConciliacaoCaixaService;
    }
    
    public function geraRelatorioConciliacao(DTO\Request $request, DTO\Response $response) {
        
        try{
            $dados = $request->getRow();
        
            $execProcedure = $this->Rec57001RelatorioConciliacaoCaixaService->execProcRecConCaixa($dados);
            
            $reportName =  'FIN0002';
        
            $parametersRow = array (
                "NRORG" =>  $this->nrorg,
                "NRSEQCONCTEMP" =>  $execProcedure,
                "__format" => 'pdf'
            );

            $birtURL = $this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow);
            $response->addMessage(new DTO\Response\Message($birtURL));
            
        }catch(\Exception $e) {
        $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
      }
    }
        
}