<?php
namespace Teknisa\FIN\Modules\ContaPagar\Services\Pix;

use Teknisa\FIN\Modules\ContaPagar\Services\Pix\Banco\GeraPixSicoobService;
use Doctrine\ORM\EntityManager;

class GeraPixService {
    
	const CODIGO_COMPENSACAO_SANTANDER  = "033";
    const CODIGO_COMPESACAO_BRADESCO    = "237";
    const CODIGO_COMPESACAO_ITAU        = "341";
    const CODIGO_COMPESACAO_EFI         = "364";
    const CODIGO_COMPESACAO_BRASIL      = "001";
    const CODIGO_COMPESACAO_CAIXA       = "104";
    const CODIGO_COMPESACAO_SICOOB      = "756";
    const CODIGO_COMPESACAO_SICREDI     = "748";
    const CODIGO_COMPESACAO_SOFISA      = "637";
    const CODIGO_COMPESACAO_VOTORANTIM  = "655";
    const CODIGO_COMPENSACAO_DAYCOVAL   = "707";
    const CODIGO_COMPENSACAO_BANRISUL   = "041";
    
    function __construct(EntityManager $entityManager, GeraPixSicoobService $geraPixSicoobService) {
        $this->entityManager        = $entityManager;
        $this->geraPixSicoobService = $geraPixSicoobService;
    }
    
    /**
     * Inicia Pagamento Pix
     */
    public function iniciaPagamentoPix($cdbanco, $cdclientid, $dsdircertificado, $cdsenhacertif, $chavepix, $dataAgendamento, $nomefornecedor, $inscricao, $valor, $descricao, $homologacao = true){
        try {
            if($cdbanco == self::CODIGO_COMPESACAO_SICOOB){
                $endtoendid = $this->geraPixSicoobService->iniciaPagamentoPix($cdbanco, $cdclientid, $dsdircertificado, $cdsenhacertif, $chavepix, $dataAgendamento, $nomefornecedor, $inscricao, $valor, $descricao, $homologacao);
            }else $endtoendid = null;
            
            return $endtoendid;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    /**
     * Confirma Pagamento Pix
     */
    public function confirmaPagamentoPix($endetoendid, $cdbanco, $cdclientid, $dsdircertificado, $cdsenhacertif, $chavepix, $dataAgendamento, $nomefornecedor, $inscricao, $valor, $descricao, $homologacao = true){
        try {
            if($cdbanco == self::CODIGO_COMPESACAO_SICOOB){
                $pagamento = $this->geraPixSicoobService->confirmaPagamentoPix($endetoendid, $cdbanco, $cdclientid, $dsdircertificado, $cdsenhacertif, $chavepix, $dataAgendamento, $nomefornecedor, $inscricao, $valor, $descricao, $homologacao);
            }else $pagamento = null;
            
            return $pagamento;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    /**
     * Consulta Pagamento Pix
     */
    public function consultaPagamentoPix($endetoendid, $cdbanco, $cdclientid, $dsdircertificado, $cdsenhacertif, $chavepix, $dataAgendamento, $nomefornecedor, $inscricao, $valor, $descricao, $homologacao = true){
        try {
            if($cdbanco == self::CODIGO_COMPESACAO_SICOOB){
                $pagamento = $this->geraPixSicoobService->consultaPagamentoPix($endetoendid, $cdbanco, $cdclientid, $dsdircertificado, $cdsenhacertif, $chavepix, $dataAgendamento, $nomefornecedor, $inscricao, $valor, $descricao, $homologacao);
            }else $pagamento = null;
            
            return $pagamento;
        } catch (\Exception $e) {
            throw $e;
        }
    }
}