<?php
namespace Teknisa\FIN\Modules\ContaReceber\Services\Remessa\Banco;

use Financeiro\Entities\Emprbanc;
use Financeiro\Entities\Boletreceber;
use Geral\Entities\Banco;
use Geral\Entities\Endeclie;
use Geral\Entities\Licencauso;
use Geral\Entities\Contcorr;
use \Geral\Entities\Empresa;
use Geral\Util\Ambiente;
use Teknisa\Libs\Util\DateUtil;
use \Financeiro\Util\Util;
use \Geral\Entities\Cliente;
use Geral\Entities\Filial;
use Teknisa\FIN\Modules\ContaReceber\Services\Remessa\GeraCnabService;

class GeraCnabSicoobService extends GeraCnabService{

    const CODIGO_BANCO = '756';
    const LOTE_DO_SERVICO_HEADER = '0000';
    const LOTE_DO_SERVICO = '0001';
    const LOTE_SERVICO_TRAILLER = '9999';
    const REGISTRO_HEADER = '0';
    const ID_ARQUIVO_REMESSA = '1';
    const NUMERO_SEQUENCIAL = '000001';
    const LAYOUT_ARQUIVO = '081';
    const DENSIDADE_GRAVACAO = '00000';
    const ID_ARQUIVO_LOTE = '5';
    const NUMERO_LOTE = '0001';
    const TIPO_REGISTRO_LOTE = '1';
    const TIPO_OPERACAO = 'R';
    const TIPO_SERVICO = '01';
    const VERSAO_ARQUIVO = '040';
    const TIPO_DE_REGISTRO_DETALHE = '3';
    const CODIGO_SEGMENTO_P = 'P';
    const CODIGO_SEGMENTO_Q = 'Q';
    const CODIGO_SEGMENTO_R = 'R';
    const CODIGO_MOVIMENTO = '01';
    const TIPO_FORMULARIO = '1';
    const FORMA_CADASTRAMENTO = '0';
    const ESPECIE_TITULO = '02';
    const ID_TITULO_ACEITO = 'A';
    const CODIGO_DESCONTO = '0';
    const CODIGO_PARA_BAIXA = '0';
    const CODIGO_MOEDA = '09';
    const TIPO_DE_REGISTRO_TRAILLER = '9';
    const TIPO_DE_REGISTRO_TRAILLER_LOTE = '5';
    //Quantidade de registro do arquivo
    private $seqReg = 0;
    //ValorTotalBoleto
    private $vrTotalBoletos = 0;
    // Quantidade de títulos em cobrança Simples
    private $qtdRegSimples = 0;
    
    private $qtdRegistros = 0;
    
     //#################################################################//
     //############### REGISTRO HEADER DE ARQUIVO ######################//
     //#################################################################//

    public function geraHeaderArquivo($caminho, $nmarquivo, $nrorg, $cdbanco, $cdempresa, $cdidrec, $nrseqremessarec, $nrcnab, $cdreducont, $carteira = NULL, $contreg = NULL, $idtipcnabrec = NULL, $cdfilial, $contador = NULL){
        $this->qtdRegistros++;
        if (!is_dir($caminho))
            mkdir($caminho, "0777", true);
        $nmarquivo = $caminho.$nmarquivo;
        $file = fopen($nmarquivo, "w+");

        // CAMPO: Código do Banco
        // POSIÇÃO: 001 a 003
        // PICTURE: 9(3)
        $arquivo = self::CODIGO_BANCO;
        
        // CAMPO: Zeros
        // POSIÇÃO: 004 a 007
        // PICTURE: 9(4)
        $arquivo .= self::LOTE_DO_SERVICO_HEADER;
        

        // CAMPO: Registro Header de Lote
        // POSIÇÃO: 008 a 008
        // PICTURE: 9(1)
        $arquivo .= self::REGISTRO_HEADER;

        // CAMPO: Brancos
        // POSIÇÃO: 009 a 017
        // PICTURE: X(9)
        $arquivo .= self::preenche_brancos(' ', 9);
        
        
        // CAMPO: Tipo de Inscrição
        // POSIÇÃO: 018 a 018
        // PICTURE: 9(1)
        /** @var $empresa Empresa */
        
        $empresa = Empresa::findOneByCdempresa($cdempresa);
        $filial = Filial::findOneByCdfilial($cdfilial);
        
        if($filial){
            if($filial->getIdtpijurfili() == 'F'){
                $tipoInscricaoCedente = '1'; //CPF
            } else {
                $tipoInscricaoCedente = '2'; //CNPJ
            }
            
            $arquivo .= $tipoInscricaoCedente;
            
            // CAMPO: Número de Inscrição da Filial
            // POSIÇÃO: 019 a 032
            // PICTURE: 9(14)
             $arquivo .= $filial->getNrinsjurfili();
            
        } else {
            if($empresa->getIdtpijurempr() == 'F'){
                $tipoInscricaoCedente = '1'; //CPF
            } else {
                 $tipoInscricaoCedente = '2'; //CNPJ
            }
            
            $arquivo .= $tipoInscricaoCedente;
            
            // CAMPO: Número de Inscrição da Empresa
            // POSIÇÃO: 019 a 032
            // PICTURE: 9(14)
            $arquivo .= $empresa->getNrinsjurempr();
            
        }

        // CAMPO: Código do Convênio no Sicoob: Brancos
        // POSIÇÃO: 033 a 052
        // PICTURE: X(20)
        $arquivo .= self::preenche_brancos('', 20);

        // CAMPO: Cooperativa Cliente + DV Cooperativa Cliente
        // POSIÇÃO: 053 a 058
        // PICTURE: 9(6)
        $contcorr = Contcorr::findOneByCdreducont($cdreducont);
        if($contcorr->getCdagencia()){
            $banco = Banco::findOneByCdbancoAndNrorg($cdbanco, $nrorg);
            $digitoAgencia   = (strpos($banco->getCdpictagen(), "-") > -1)?true:false;
            if($digitoAgencia){
                $arquivo .= str_pad(substr($contcorr->getCdagencia(),0,4),5,'0',STR_PAD_LEFT);
                $arquivo .=substr($contcorr->getCdagencia(),-1);
            } else {
                $arquivo .= str_pad($contcorr->getCdagencia(), 6, '0', STR_PAD_LEFT);
            }
        }else{
            $arquivo = str_pad($arquivo, 58, '0');
        }

        // CAMPO: Conta Corrente Cliente + DV conta cliente
        // POSIÇÃO: 059 a 071
        // PICTURE: 9(13)
        $arquivo .= str_pad($contcorr->getCdcontcorr(), 13, '0', STR_PAD_LEFT);
        
        // CAMPO: Brancos
        // POSIÇÃO: 072 a 072
        // PICTURE: X(1)
        $arquivo = str_pad($arquivo, 72, '0');
        
        // CAMPO: Nome da Empresa
        // POSIÇÃO: 073 a 102
        // PICTURE: X(30)
        
        $empresa = Empresa::findOneByCdempresa($cdempresa);
        $filial = Filial::findOneByCdfilial($cdfilial);
            
        // Caso seja informado filial na geração do CNAB, sera inserido nome da razão social da filial e não da empresa no arquivo
        if($filial) {
            $nmrazsocemp = Util::campoCnabValido($filial->getNmrazsocfili());
            $nmrazsocemp = substr($nmrazsocemp, 0, 30);
            $arquivo .= str_pad($nmrazsocemp, 30);
        } else {
            $nmrazsocemp = Util::campoCnabValido($empresa->getNmrazsocempr());
            $nmrazsocemp = substr($nmrazsocemp, 0, 30);
            $arquivo .= str_pad($nmrazsocemp, 30);
        }
        
        // CAMPO: Nome do banco
        // POSIÇÃO: 103 a 132
        // PICTURE: X(30)
        $arquivo .= 'SICOOB';
        $arquivo .= self::preenche_brancos('', 24);

        // CAMPO: Brancos
        // POSIÇÃO: 133 a 142
        // PICTURE: X(10)
         $arquivo .= self::preenche_brancos('', 10);
        
        // CAMPO: Identificação do Arquivo de Remessa
        // POSIÇÃO: 143 a 143
        // PICTURE: 9(1)
        // CONTEUDO: '1'
        $arquivo .= self::ID_ARQUIVO_REMESSA;
        
        // CAMPO: Data de Geração do arquivo
        // POSIÇÃO: 144 a 151
        // PICTURE: 9(8)
        $now = DateUtil::getDataDeString(DateUtil::truncateString(DateUtil::getDataAtual()));
        $data = DateUtil::getDia($now) . DateUtil::getMes($now) . DateUtil::getAno($now);
        $arquivo .= Util::campoCnabValido($data);

        // CAMPO: Hora de Geração do arquivo
        // POSIÇÃO: 152 a 157
        // PICTURE: 9(6)
        $now = DateUtil::getDataAtual();
        $horaGeracao = $now->format('His');
        $arquivo .= $horaGeracao;
        
        // CAMPO: Número Seqüencial
        // POSIÇÃO: 158 a 163
        // PICTURE: 9(6)
        
        if(empty($nrseqremessarec)){
            $arquivo .= self::NUMERO_SEQUENCIAL;
        } else {
            $arquivo .=  substr($nrseqremessarec, -6);
        }
        
        // CAMPO: Versão do layout do Arquivo
        // POSIÇÃO: 164 a 166
        // PICTURE: X(3)
        $arquivo .= self::LAYOUT_ARQUIVO;
        
        // CAMPO: Densidade de gravação do arquivo
        // POSIÇÃO: 167 a 171
        // PICTURE: X(5)
        $arquivo .= self::DENSIDADE_GRAVACAO;
        
        // CAMPO: Reservado para o Banco
        // POSIÇÃO: 172 a 191
        // PICTURE: X(20)
        $arquivo .= self::preenche_brancos('', 20);
        
        // CAMPO: Reservado para a Empresa
        // POSIÇÃO: 192 a 211
        // PICTURE: X(20)
        $arquivo .= self::preenche_brancos('', 20);
        
        // CAMPO: Brancos
        // POSIÇÃO: 212 a 240
        // PICTURE: X(029)
        $arquivo = str_pad($arquivo, 240) . "\r\n";

        //Grava a variavel arquivo no arquivo texto
        fprintf($file, "%s", $arquivo);
        fclose($file);
    }
    
     //#################################################################//
     //################  REGISTRO HEADER DE LOTE  ######################//
     //#################################################################//
    
    public function geraHeaderLote($caminho, $nmarquivo, $nrorg, $cdbanco, $cdempresa, $cdidrec, $nrseqremessarec, $nrcnabrec, $cdreducont, $carteira = NULL, $cdfilial){
        $this->qtdRegistros++;
        if (!is_dir($caminho))
            mkdir($caminho, "0777", true);
        $nmarquivo = $caminho.$nmarquivo;
        $file = fopen($nmarquivo, "a+");

        // CAMPO: Código do Banco
        // POSIÇÃO: 001 a 003
        // PICTURE: 9(3)
        $arquivo = self::CODIGO_BANCO;

        // CAMPO: Lote de Serviço
        // POSIÇÃO: 004 a 007
        // PICTURE: 9(4)
        $arquivo .= self::NUMERO_LOTE;

        // CAMPO: Tipo de Registro
        // POSIÇÃO: 008 a 008
        // PICTURE: 9(1)
        $arquivo .= self::TIPO_REGISTRO_LOTE;

        // CAMPO: Tipo de Operação
        // POSIÇÃO: 009 a 009
        // PICTURE: X(1)
        $arquivo .= self::TIPO_OPERACAO;
        
        // CAMPO: Tipo de Serviço
        // POSIÇÃO: 010 a 011
        // PICTURE: 9(2)
        $arquivo .= self::TIPO_SERVICO;
        
        // CAMPO: Forma de Lançamento
        // POSIÇÃO: 012 a 013
        // PICTURE: X(2)
        $arquivo .= self::preenche_brancos(' ', 2);
        
        // CAMPO: Versão do Arquivo
        // POSIÇÃO: 014 a 016
        // PICTURE: X(3)
        $arquivo .= self::VERSAO_ARQUIVO;
        
        // CAMPO: Brancos
        // POSIÇÃO: 017 a 017
        // PICTURE: 9(1)
        $arquivo .= self::preenche_brancos(' ', 1);

        $empresa = Empresa::findOneByCdempresa($cdempresa);
        $filial = Filial::findOneByCdfilial($cdfilial);
        
        if($filial){
            // CAMPO: Tipo de Inscrição
            // POSIÇÃO: 018 a 018
            // PICTURE: 9(1)
            if($filial->getIdtpijurfili() == 'F'){
                $tipoInscricaoCedente = '1'; //CPF
            } else {
                $tipoInscricaoCedente = '2'; //CNPJ
            }
            
            $arquivo .= $tipoInscricaoCedente;
            
            // CAMPO: Número de Inscrição da Filial
            // POSIÇÃO: 019 a 033
            // PICTURE: 9(14)
             $arquivo .= str_pad($filial->getNrinsjurfili(), 15, '0', STR_PAD_LEFT);
            
        } else {
            if($empresa->getIdtpijurempr() == 'F'){
                $tipoInscricaoCedente = '1'; //CPF
            } else {
                 $tipoInscricaoCedente = '2'; //CNPJ
            }
            
            $arquivo .= $tipoInscricaoCedente;
            
            // CAMPO: Número de Inscrição da Empresa
            // POSIÇÃO: 019 a 033
            // PICTURE: 9(14)
            $arquivo .= str_pad($empresa->getNrinsjurempr(), 15, '0', STR_PAD_LEFT);
            
        }
        
        // CAMPO: Uso Exclusivo do Banco
        // POSIÇÃO: 034 a 053
        // PICTURE: X(20)
        $arquivo .= self::preenche_brancos(' ', 20);

        // CAMPO: Cooperativa Cliente + DV Cooperativa Cliente
        // POSIÇÃO: 054 a 059
        // PICTURE: 9(6)
        $contcorr = Contcorr::findOneByCdreducont($cdreducont);
        if($contcorr->getCdagencia()){
           $banco = Banco::findOneByCdbancoAndNrorg($cdbanco, $nrorg);
            $digitoAgencia   = (strpos($banco->getCdpictagen(), "-") > -1)?true:false;
            if($digitoAgencia){
                $arquivo .= str_pad(substr($contcorr->getCdagencia(),0,4),5,'0',STR_PAD_LEFT);
                $arquivo .=substr($contcorr->getCdagencia(),-1);
            } else {
                $arquivo .= str_pad($contcorr->getCdagencia(), 6, '0', STR_PAD_LEFT);
            }
        }else{
            $arquivo = str_pad($arquivo, 58, '0');
        }
        
        // CAMPO: Conta Corrente
        // POSIÇÃO: 060 a 72
        // PICTURE: X(13)
        if(!$contcorr->getCdcontcorr()){
            $arquivo = str_pad($arquivo, 72, '0');
        } else {
            $arquivo .= str_pad($contcorr->getCdcontcorr(), 13, '0', STR_PAD_LEFT);
        }

        // CAMPO: Uso Exclusivo do Banco
        // POSIÇÃO: 073 a 73
        // PICTURE: X(1)
        $arquivo .= self::preenche_brancos(' ', 1);

        // CAMPO: Nome da Empresa
        // POSIÇÃO: 072 a 0103
        // PICTURE: X(30)
        $empresa = Empresa::findOneByCdempresa($cdempresa);
        $filial = Filial::findOneByCdfilial($cdfilial);
            
        // Caso seja informado filial na geração do CNAB, sera inserido nome da razão social da filial e não da empresa no arquivo
        if($filial) {
            $nmrazsocemp = Util::campoCnabValido($filial->getNmrazsocfili());
            $nmrazsocemp = substr($nmrazsocemp, 0, 30);
            $arquivo .= str_pad($nmrazsocemp, 30);
        } else {
            $nmrazsocemp = Util::campoCnabValido($empresa->getNmrazsocempr());
            $nmrazsocemp = substr($nmrazsocemp, 0, 30);
            $arquivo .= str_pad($nmrazsocemp, 30);
        }
        
        // CAMPO: Mensagem 01
        // POSIÇÃO: 104 a 143
        // PICTURE: X(40)
        $arquivo .= self::preenche_brancos('', 40);
        
        // CAMPO: Mensagem 02
        // POSIÇÃO: 144 a 183
        // PICTURE: X(40)
        $arquivo .= self::preenche_brancos('', 40);

        // CAMPO: Número REMESSA/RETORNO
        // POSIÇÃO: 184 a 191
        // PICTURE: 9(8)
        $arquivo .= substr($nrcnabrec, -8);

        // CAMPO: Data de Gravação REMESSA/RETORNO
        // POSIÇÃO: 192 a 199
        // PICTURE: 9(8)
        $now = DateUtil::getDataDeString(DateUtil::truncateString(DateUtil::getDataAtual()));
        $data = DateUtil::getDia($now) . DateUtil::getMes($now) . DateUtil::getAno($now);
        $arquivo .= Util::campoCnabValido($data);
        
        // CAMPO: Data do Crédito
        // POSIÇÃO: 200 a 207
        // PICTURE: 9(8)
        $arquivo = str_pad($arquivo, 207, '0');

        // CAMPO: Brancos
        // POSIÇÃO: 208 a 240
        // PICTURE: X(33)
        $arquivo = str_pad($arquivo, 240) . "\r\n";

        //Grava a variavel arquivo no arquivo texto
        fprintf($file, "%s", $arquivo);
        fclose($file);
    }

    //#################################################################//
    //################  Registro Detalhe Segmento P  ##################//
    //#################################################################//
    public function geraDetalheSegmentoP($caminho, $nmarquivo, $nrorg, $cdbanco, $cdempresa, $cdidrec, $nrseqremessarec,
                                                  $nrcnabrec, $idoperacao, $cdagenciacnab, $cdcontacorrente, $cdcontcorrcobranca, $nossonumero,
                                                  $idtipocobranca, $nrlanbolrec, $cdfilial, $dtvenbolrec, $valorfinalboleto, $valorpemobrec, $valormordiabrec,
                                                  $valorpemulbrec, $valormultabrec, $valorfinalbrec, $cdcartcobbol, $cddiaprotbol, $cdreducont, $imprbol,
                                                  $qtdiaprotbol, $contador = NULL
    ){
        $this->seqReg++;
        $this->qtdRegistros++;
        // Contador de Cobrança
        if ($idtipocobranca == 1){
            $this->qtdRegSimples += $idtipocobranca;
        }
        
        if (!is_dir($caminho))
            mkdir($caminho, "0777", true);
        $nmarquivo = $caminho.$nmarquivo;
        $file = fopen($nmarquivo, "a+");

        // CAMPO: Código do Banco
        // POSIÇÃO: 001 a 003
        // PICTURE: 9(3)
        $arquivo = self::CODIGO_BANCO;
        
        // CAMPO: Lote de Serviço
        // POSIÇÃO: 004 a 007
        // PICTURE: 9(4)
        $arquivo .= self::LOTE_DO_SERVICO;

        // CAMPO: Identificação do registro
        // POSIÇÃO: 008 a 008
        // PICTURE: 9(1)
        $arquivo .= self::TIPO_DE_REGISTRO_DETALHE;

        // CAMPO: Nº seq. do reg. no lote
        // POSIÇÃO: 009 a 013
        // PICTURE: 9(5)
        $contador = str_pad($this->seqReg, 5, "0", STR_PAD_LEFT);
        $arquivo .= Util::campoCnabValido($contador);

        // CAMPO: Código do Segmento
        // POSIÇÃO: 014 a 014
        // PICTURE: X(1)
        $arquivo .= self::CODIGO_SEGMENTO_P;
        
        // CAMPO: Brancos
        // POSIÇÃO: 015 a 015
        // PICTURE: X(1)
        $arquivo = str_pad($arquivo, 15);
        
        // CAMPO: Código do Movimento
        // POSIÇÃO: 016 a 017
        // PICTURE: 9(2)
        $arquivo .= self::CODIGO_MOVIMENTO;
        
        // CAMPO: Agência mantenedora da conta
        // POSIÇÃO: 018 a 022
        // PICTURE: X(6)
        /** @var $contcorr Contcorr */
        $contcorr = Contcorr::findOneByCdreducont($cdreducont);
        if($contcorr->getCdagencia()){
            $arquivo .= str_pad(substr($contcorr->getCdagencia(),0,4),5,'0',STR_PAD_LEFT);
        }else{
            $arquivo = str_pad($arquivo, 22, '0');
        }
        
        // CAMPO: Uso Exclusivo do Banco
        // POSIÇÃO: 023 a 023
        // PICTURE: X(1)
        $arquivo = str_pad($arquivo, 23, '0');
        
        // CAMPO: Conta Corrente
        // POSIÇÃO: 024 a 035
        // PICTURE: X(12)
        if(!$contcorr->getCdcontcorr()){
            $arquivo = str_pad($arquivo, 72, '0');
        } else {
            $arquivo .= str_pad($contcorr->getCdcontcorr(), 13, '0', STR_PAD_LEFT);
        }
        
        // CAMPO: Uso Exclusivo do Banco
        // POSIÇÃO: 036 a 037
        // PICTURE: X(1)
        $arquivo .= self::preenche_brancos(' ',1);
        
        // CAMPO: Nosso Número
        // POSIÇÃO: 038 a 047
        // PICTURE: 9(10)
        $boleto = Boletreceber::findOneByNrlanbolrecAndCdfilial($nrlanbolrec, $cdfilial);
        if($boleto->getIdimprbolbol() == 'E'){
            if(empty($boleto->getCdnosnumrec())){
                $arquivo = str_pad($arquivo, 47, '0');
            } else {
                $arquivo .= str_pad(str_replace(['', '-'], '0', $nossonumero), 10, '0', STR_PAD_LEFT);
            }
        } else {
            $arquivo = str_pad($arquivo, 47, '0');
        }

        // CAMPO: Número da Parcela
        // POSIÇÃO: 048 a 049
        // PICTURE: 9(2)
        $boleto = Boletreceber::findOneByNrlanbolrecAndCdfilial($nrlanbolrec, $cdfilial);
        if($boleto->getNrparcbolrec() == '00'){
            $arquivo .= '01';
        } else{
            $arquivo .= $boleto->getNrparcbolrec();
        }

        // CAMPO: Nº da carteira
        // POSIÇÃO: 050 a 051
        // PICTURE: 9(2)
        // CONTEÚDO:
        //           1      - Modalidade Simples;
        //           2      - Garantia Vinculada;   
        //           3      - Garantia Caucionada;
        switch($boleto->getIdcartcobrec()){
            case '1':
                $arquivo .= '01';
                break;
            case '2':
                $arquivo .= '02';
                break;
            case '3':
                $arquivo .= '03';
                break;
        }
        
        // CAMPO: Tipo de Forulario
        // POSIÇÃO: 52 a 52
        // PICTURE: 9(1)
        $arquivo .= self::TIPO_FORMULARIO;
        
        // CAMPO: Uso Exclusivo do Banco
        // POSIÇÃO: 053 a 057
        // PICTURE: 9(5)
        $arquivo .= self::preenche_brancos(' ',5);
        
        //CAMPO: Carteira
        //POSIÇÃO: 58 a 58
        //PICTURE: 9(1)
        if($idtipocobranca){
            if($idtipocobranca == '1'){
                $arquivo .= '1';
            }
            elseif($idtipocobranca == '3')
                $arquivo .= '3';
            elseif($idtipocobranca == '4')
                $arquivo .= '4';
        }
        
        // CAMPO: Forma de Cadastramento
        // POSIÇÃO: 059 a 059
        // PICTURE: X(1)
        $arquivo .= self::FORMA_CADASTRAMENTO;
        
        // CAMPO: Tipo de Documento
        // POSIÇÃO: 060 a 060
        // PICTURE: X(1)
        $arquivo .= self::preenche_brancos(' ',1);

        // CAMPO: Emissão do Boleto
        // POSIÇÃO: 061 a 061
        // PICTURE: X(1)
        if($imprbol == 'E'){
            $arquivo .= '2';
        } else {
            $arquivo .= '1';
        }

        // CAMPO: Distribui Boleto
        // POSIÇÃO: 062 a 062
        // PICTURE: X(1)
        if($imprbol == 'E'){
            $arquivo .= '2';
        } else {
            $arquivo .= '1';
        }

        // CAMPO: Identificação do título na empresa
        // POSIÇÃO: 063 a 077
        // PICTURE: X(15)
        /** @var $entityBoleto \Financeiro\Repositories\Boletreceber */
        $entityBoleto = Boletreceber::getRepository();
        $duplicata = $entityBoleto->getDuplicata($cdfilial, $nrlanbolrec);
        if (!$duplicata[0]['DUPLICATA'])
            $arquivo .= str_pad($nrlanbolrec, 15);
        else {
            //$arquivo .= str_pad($duplicata[0]['DUPLICATA']. $duplicata[0]['NRPARCELA'], 15);
            $duplicataAjustada = str_pad($duplicata[0]['DUPLICATA'],10,0,STR_PAD_LEFT);
            $parcela = $duplicata[0]['NRPARCELA'];
            $arquivo .= str_pad($duplicataAjustada.$parcela,15);
        }
        
        // CAMPO: Data de vencimento do título
        // POSIÇÃO: 078 a 085
        // PICTURE: 9(8)
        $vencimento = DateUtil::getDataDeString(DateUtil::truncateString($dtvenbolrec));
        $data = DateUtil::getDia($vencimento) . DateUtil::getMes($vencimento) . DateUtil::getAno($vencimento);
        $arquivo .= Util::campoCnabValido($data);

        // CAMPO: Valor do título
        // POSIÇÃO: 086 a 100
        // PICTURE: 9(13)V9(2)
        $vr = $valorfinalboleto * 100;
        $vrfinabolrec = str_pad($vr, 15, "0", STR_PAD_LEFT);
        $this->vrTotalBoletos +=  $valorfinalboleto;
        $arquivo .= Util::campoCnabValido($vrfinabolrec);
        
        // CAMPO: Uso Exclusivo do Banco
        // POSIÇÃO: 101 a 105
        // PICTURE: 9(5)
        $arquivo = str_pad($arquivo, 105, '0');

        // CAMPO: Uso Exclusivo do Banco
        // POSIÇÃO: 106 a 106
        // PICTURE: X(1)
        $arquivo .= self::preenche_brancos(' ', 1);
    
        // CAMPO: Espécie do título
        // POSIÇÃO: 107 a 108
        // PICTURE: 9(2)
        $arquivo .= self::ESPECIE_TITULO;
        
        // CAMPO: Identificação de título aceito ou não aceito
        // POSIÇÃO: 109 a 109
        // PICTURE: X(1)
        $arquivo .= self::ID_TITULO_ACEITO;
        
        // CAMPO: Data de emissão do título
        // POSIÇÃO: 110 a 117
        // PICTURE: 9(8)
        $now = DateUtil::getDataDeString(DateUtil::truncateString(DateUtil::getDataAtual()));
        $data = DateUtil::getDia($now) . DateUtil::getMes($now) . DateUtil::getAno($now);
        $arquivo .= Util::campoCnabValido($data);
        
        // CAMPO: Código de Juros de Mora
        // POSIÇÃO: 118 a 118
        // PICTURE: 9(1)
        //1 = Valor por Dia; 2 = Taxa Mensal e 3 = Isento.
        
        // CAMPO: Data de Juros de Mora
        // POSIÇÃO: 119 a 126
        // PICTURE: 9(8)
        
        // CAMPO: Valor de mora por dia de atraso
        // POSIÇÃO: 127 a 141
        // PICTURE: 9(13)V9(2)
        if($valormordiabrec == 0 && $valorpemobrec == 0){
           $arquivo .= '0';
           $arquivo = str_pad($arquivo, 8, '0');
           $arquivo = str_pad($arquivo, 15, '0');
        } else if($valormordiabrec == 0){
            $arquivo .= '2';
            $vencimento = DateUtil::getDataDeString(DateUtil::truncateString($dtvenbolrec));
            $vencimento = DateUtil::adicionaIntervalo($vencimento, 1);
            $data = DateUtil::getDia($vencimento) . DateUtil::getMes($vencimento) . DateUtil::getAno($vencimento);
            $arquivo .= Util::campoCnabValido($data);
            $vrpemorbrec = str_pad(($valorpemobrec * 100), 15, "0", STR_PAD_LEFT);
            $arquivo .= $vrpemorbrec;
        }else {
            $arquivo .= '1';
            $vencimento = DateUtil::getDataDeString(DateUtil::truncateString($dtvenbolrec));
            $vencimento = DateUtil::adicionaIntervalo($vencimento, 1);
            $data = DateUtil::getDia($vencimento) . DateUtil::getMes($vencimento) . DateUtil::getAno($vencimento);
            $arquivo .= Util::campoCnabValido($data);
            $valormordiabrec = str_pad(($valormordiabrec * 100), 15, "0", STR_PAD_LEFT);
            $arquivo .= $valormordiabrec;
        }
        
        // CAMPO: Código do Desconto
        // POSIÇÃO: 142 a 142
        // PICTURE: 9(1)
        $arquivo .= self::CODIGO_DESCONTO;

        // CAMPO: Data de Desconto
        // POSIÇÃO: 143 a 150
        // PICTURE: 9(8)
        $arquivo = str_pad($arquivo, 150, '0');

        // CAMPO: Valor do Desconto
        // POSIÇÃO: 151 a 165
        // PICTURE: 9(13)V9(2)
        $arquivo = str_pad($arquivo, 165, '0');

        // CAMPO: Valor do I.O.F.
        // POSIÇÃO: 166 a 180
        // PICTURE: 9(13)V9(2)
        $arquivo = str_pad($arquivo, 180, '0');

        // CAMPO: Valor do Abatimento
        // POSIÇÃO: 181 a 195
        // PICTURE: 9(13)V9(2)
        $arquivo = str_pad($arquivo, 195, '0');

        // CAMPO: Identificação do Título na Empresa
        // POSIÇÃO: 196 a 220
        // PICTURE: X(25)
        $arquivo .= str_pad($cdfilial.$nrlanbolrec, 25);

        if(!$cddiaprotbol)
            $diaprotbol = '3';
        else
            $diaprotbol = substr($cddiaprotbol, -1);

        if(!$qtdiaprotbol)
            $quantidadedia = '00';
        else
            $quantidadedia = substr($qtdiaprotbol, -2);

        if ($diaprotbol == '3' or $quantidadedia == '00') {
            $diaprotbol = '3';
            $quantidadedia = '00';
        }

        // CAMPO: Código para Protesto
        // POSIÇÃO: 221 a 221
        // PICTURE: 9(1)
        $arquivo .= $diaprotbol;
        
        // CAMPO: Prazo para Protesto
        // POSIÇÃO: 222 a 223
        // PICTURE: 9(2)
        $arquivo .= $quantidadedia;

        // CAMPO: Uso Exclusivo do Banco
        // POSIÇÃO: 224 a 224
        // PICTURE: 9(1)
        $arquivo .= self::CODIGO_PARA_BAIXA;
        
        // CAMPO: Uso Exclusivo do Banco
        // POSIÇÃO: 225 a 227
        // PICTURE: 9(3)
        $arquivo .= self::preenche_brancos(' ', 3);
        
        // CAMPO: Código da moeda
        // POSIÇÃO: 228 a 229
        // PICTURE: 9(2)
        $arquivo .= self::CODIGO_MOEDA;

        // CAMPO: Número do Contrato da Operação
        // POSIÇÃO: 230 a 239
        // PICTURE: X(10)
        $arquivo = str_pad($arquivo, 239, '0');
        
        // CAMPO: Uso Exclusivo CNAB
        // POSIÇÃO: 240 a 240
        // PICTURE: X(1)
        $arquivo = str_pad($arquivo, 240) . "\r\n";

        //Grava a variavel arquivo no arquivo texto
        fprintf($file, "%s", $arquivo);
        fclose($file);
    }
    
    //#################################################################//
    //################  Registro Detalhe Segmento Q  ##################//
    //#################################################################//
    public function geraDetalheSegmentoQ($caminho, $nmarquivo, $nrorg, $cdbanco, $cdcliente, $idoperacao, $cdempresa, $cdfilial, $nrlanbolrec, $contador = NULL){
        $this->seqReg++;
        $this->qtdRegistros++;
        if (!is_dir($caminho))
            mkdir($caminho, "0777", true);
        $nmarquivo = $caminho.$nmarquivo;
        $file = fopen($nmarquivo, "a+");

        // CAMPO: Código do Banco
        // POSIÇÃO: 001 a 003
        // PICTURE: 9(3)
        $arquivo = self::CODIGO_BANCO;

        // CAMPO: Lote de Serviço
        // POSIÇÃO: 004 a 007
        // PICTURE: 9(4)
        $arquivo .= self::LOTE_DO_SERVICO;

        // CAMPO: Identificação do registro
        // POSIÇÃO: 008 a 008
        // PICTURE: 9(1)
        $arquivo .= self::TIPO_DE_REGISTRO_DETALHE;

        // CAMPO: Nº seq. do reg. no lote
        // POSIÇÃO: 009 a 013
        // PICTURE: 9(5)
        $contador = str_pad($this->seqReg, 5, "0", STR_PAD_LEFT);
        $arquivo .= Util::campoCnabValido($contador);
        
        // CAMPO: Código do Segmento
        // POSIÇÃO: 014 a 014
        // PICTURE: X(1)
        $arquivo .= self::CODIGO_SEGMENTO_Q;

        // CAMPO: Brancos
        // POSIÇÃO: 015 a 015
        // PICTURE: X(1)
        $arquivo = str_pad($arquivo, 15);
        
        // CAMPO: Código do Movimento
        // POSIÇÃO: 016 a 017
        // PICTURE: 9(2)
        $arquivo .= self::CODIGO_MOVIMENTO;

        /** @var $entityLicencaUso \Geral\Repositories\Licencauso */
        $entityLicencaUso = Licencauso::getRepository();

        $licencauso = $entityLicencaUso->getLicencaUso($cdfilial, $nrlanbolrec);
        if($licencauso){
            if($licencauso[0]['IDTPIJURLUSO'] == 'F')
                $tipoSacado = '1'; //CPF
            else
                $tipoSacado = '2'; //CNPJ

            if($licencauso[0]['NRINSJURLUSO'])
                $nrinsjur = $licencauso[0]['NRINSJURLUSO'];
            if(isset($licencauso[0]['NRCEPLUSO']))
                $nrcep = $licencauso[0]['NRCEPLUSO'];
            else
                $nrcep = '00000000';

            $nmclie = $licencauso[0]['NMFANTLUSO'];
            $dsendeclie = $licencauso[0]['DSENDELUSO'];
            $nmbairro = $licencauso[0]['NMBAIRLUSO'];
            $nmmunicipio = $licencauso[0]['NMMUNICIPIO'];
            $sgestado = $licencauso[0]['SGESTADO'];
        }
        else{
            /** @var $entityEndeClie \Geral\Repositories\Endeclie */
            $endeclie = Endeclie::findOneByNrorgAndCdclienteAndIdtpendeclie($nrorg, $cdcliente, 'C');
            
            /** @var $boleto Boletreceber */
            $boleto = Boletreceber::findOneByNrlanbolrecAndCdfilial($nrlanbolrec, $cdfilial);
            /** @var $cliente Cliente */
            $cliente = Cliente::findOneByCdclienteAndNrorg($boleto->getCdcliente(), $nrorg);

            if($cliente->getIdtpijurclie() == 'F')
                $tipoSacado = '1'; //CPF
            else
                $tipoSacado = '2'; //CNPJ

            if($cliente->getNrinsjurclie())
                $nrinsjur = $cliente->getNrinsjurclie();
                
            if($endeclie->getNrcepclie()){
                $nrcep = $endeclie->getNrcepclie();
            } else {
                $nrcep = '00000000';
            }
            

            $nmclie = $cliente->getNmrazsocclie();
            $dsendeclie = $endeclie->getDsendeclie();
            $nmbairro = $endeclie->getNmbairclie();
            $nmmunicipio = $endeclie->getMunicipio();
            $sgestado = $endeclie->getSgestado();

        }

        // CAMPO: Código de inscrição/Sacado ('1' = CPF, '2' = CNPJ)
        // POSIÇÃO: 018 a 018
        // PICTURE: 9(1)
        $arquivo .= $tipoSacado;

        // CAMPO: Nº de inscrição do sacado (CPF/CGC)
        // POSIÇÃO: 019 a 033
        // PICTURE: 9(15)
        $arquivo .= Util::campoCnabValido(str_pad($nrinsjur, 15, '0', STR_PAD_LEFT));
        
        // CAMPO: Nome do sacado
        // POSIÇÃO: 034 a 073
        // PICTURE: X(40)
        $nomecliente = substr(Util::campoCnabValido($nmclie), 0, 40);
        $arquivo .= str_pad($nomecliente, 40);
        
        // CAMPO: Logradouro (Endereço do sacado (cliente))
        // POSIÇÃO: 074 a 113
        // PICTURE: X(40)
        $enderecoCliente = substr(Util::campoCnabValido($dsendeclie), 0, 40);
        $arquivo .= str_pad($enderecoCliente, 40);

        // CAMPO: Bairro do sacado
        // POSIÇÃO: 114 a 128
        // PICTURE: X(15)
        $bairro = substr(Util::campoCnabValido($nmbairro), 0, 15);
        $arquivo .= str_pad($bairro, 15);
        
        // CAMPO: C.E.P. do sacado
        // POSIÇÃO: 129 a 136
        // PICTURE: 9(8)
        $arquivo .= Util::campoCepTel($nrcep);

        // CAMPO: Cidade do sacado
        // POSIÇÃO: 137 a 151
        // PICTURE: X(15)
        
        $municipio = substr(Util::campoCnabValido($nmmunicipio->getNmmunicipio()), 0, 15);
        $arquivo .= str_pad($municipio, 15);
        
        // CAMPO: Estado do sacado
        // POSIÇÃO: 152 a 153
        // PICTURE: X(2)
        $arquivo .= Util::campoCnabValido(Util::campoCnabValido($sgestado));
        
        // CAMPO: Código de inscrição do sacador ou avalista
        // POSIÇÃO: 154 a 154
        // PICTURE: 9(1)
        $arquivo = str_pad($arquivo, 154, '0');
        
        // CAMPO: Nº de inscrição do sacador ou avalista
        // POSIÇÃO: 155 a 169
        // PICTURE: 9(15)
        $arquivo = str_pad($arquivo, 169, '0');
        
        // CAMPO: Nome do sacador ou avalista
        // POSIÇÃO: 170 a 209
        // PICTURE: X(40)
        $arquivo = str_pad($arquivo, 209);

        // CAMPO: Código do Banco correspondente
        // POSIÇÃO: 210 a 212
        // PICTURE: 9(3)
        $arquivo = str_pad($arquivo, 212, '0');
        
        // CAMPO: Nosso Número do Banco correspondente
        // POSIÇÃO: 213 a 232
        // PICTURE: X(20)
        $arquivo = str_pad($arquivo, 232);
        
        // CAMPO: Uso exclusivo FEBRABAN
        // POSIÇÃO: 233 a 240
        // PICTURE: X(8)
        $arquivo = str_pad($arquivo, 240) . "\r\n";
        
        //Grava a variavel arquivo no arquivo texto
        fprintf($file, "%s", $arquivo);
        fclose($file);
    }
    
    //#################################################################//
    //################  Registro Detalhe Segmento R ###################//
    //#################################################################//
    public function geraDetalheSegmentoR($caminho, $nmarquivo, $nrorg, $cdbanco, $idoperacao, $dtvenbolrec, $valorpemulbrec, $nrlanbolrec, $valormultabrec, $contador = NULL){
        $this->seqReg++;
        $this->qtdRegistros++;
        if (!is_dir($caminho))
            mkdir($caminho, "0777", true);
        $nmarquivo = $caminho.$nmarquivo;
        $file = fopen($nmarquivo, "a+");

        // CAMPO: Código do Banco
        // POSIÇÃO: 001 a 003
        // PICTURE: 9(3)
        $arquivo = self::CODIGO_BANCO;

        // CAMPO: Lote de Serviço
        // POSIÇÃO: 004 a 007
        // PICTURE: 9(4)
        $arquivo .= self::LOTE_DO_SERVICO;

        // CAMPO: Identificação do registro
        // POSIÇÃO: 008 a 008
        // PICTURE: 9(1)
        $arquivo .= self::TIPO_DE_REGISTRO_DETALHE;

        // CAMPO: Nº seq. do reg. no lote
        // POSIÇÃO: 009 a 013
        // PICTURE: 9(5)
        $contador = str_pad($this->seqReg, 5, "0", STR_PAD_LEFT);
        $arquivo .= Util::campoCnabValido($contador);

        // CAMPO: Código do Segmento
        // POSIÇÃO: 014 a 014
        // PICTURE: 9(1)
        $arquivo .= self::CODIGO_SEGMENTO_R;

        // CAMPO: Brancos
        // POSIÇÃO: 015 a 015
        // PICTURE: X(1)
        $arquivo = str_pad($arquivo, 15);

        // CAMPO: Código de Movimento
        // POSIÇÃO: 016 a 017
        // PICTURE: 9(2)
        $arquivo .= self::CODIGO_MOVIMENTO;

        // CAMPO: Código de desconto 2
        // POSIÇÃO: 018 a 018
        // PICTURE: 9(1)
        $arquivo .= self::CODIGO_DESCONTO;

        // CAMPO: Data do desconto 2
        // POSIÇÃO: 019 a 026
        // PICTURE: 9(8)
        $arquivo = str_pad($arquivo, 26, '0');

        // CAMPO: Valor / percentual
        // POSIÇÃO: 027 a 041
        // PICTURE: 9(15)
        $arquivo = str_pad($arquivo, 41, '0');

        // CAMPO: Código de desconto 3
        // POSIÇÃO: 042 a 042
        // PICTURE: 9(1)
        $arquivo .= self::CODIGO_DESCONTO;

        // CAMPO: Data do desconto 3
        // POSIÇÃO: 043 a 050
        // PICTURE: 9(8)
        $arquivo = str_pad($arquivo, 50, '0');

        // CAMPO: Valor / percentual concedido
        // POSIÇÃO: 051 a 065
        // PICTURE: 9(15)
        $arquivo = str_pad($arquivo, 65, '0');

        // CAMPO: Código da multa
        // POSIÇÃO: 066 a 066
        // PICTURE: 9(1)
        
        // CAMPO: Data da multa
        // POSIÇÃO: 067 a 074
        // PICTURE: 9(8)
        
        // CAMPO: Valor / percentual
        // POSIÇÃO: 075 a 089
        // PICTURE: 9(15)
        
        if($valorpemulbrec == 0 && $valormultabrec == 0){
           $arquivo .= '0';
           $arquivo = str_pad($arquivo, 89, '0');
        } else if($valorpemulbrec == 0){
            $arquivo .= '1';
            $vencimento = DateUtil::getDataDeString(DateUtil::truncateString($dtvenbolrec));
            $vencimento = DateUtil::adicionaIntervalo($vencimento, 1);
            $data = DateUtil::getDia($vencimento) . DateUtil::getMes($vencimento) . DateUtil::getAno($vencimento);
            $arquivo .= Util::campoCnabValido($data);
            $calcMulta = str_pad((($valormultabrec * 100) / $this->vrTotalBoletos), 15, "0", STR_PAD_LEFT);
            $arquivo .= $calcMulta;
        }else {
            $arquivo .= '2';
            $vencimento = DateUtil::getDataDeString(DateUtil::truncateString($dtvenbolrec));
            $vencimento = DateUtil::adicionaIntervalo($vencimento, 1);
            $data = DateUtil::getDia($vencimento) . DateUtil::getMes($vencimento) . DateUtil::getAno($vencimento);
            $arquivo .= Util::campoCnabValido($data);
            $calcMulta = str_pad(($valorpemulbrec * 100), 15, "0", STR_PAD_LEFT);
            $arquivo .= $calcMulta;
        }
        
        // CAMPO: Informação do banco ao sacado
        // POSIÇÃO: 090 a 099
        // PICTURE: 9(10)
        $arquivo = str_pad($arquivo, 99);

        // CAMPO: Mensagem 3
        // POSIÇÃO: 100 a 139
        // PICTURE: 9(40)
        $arquivo = str_pad($arquivo, 139);
        
        // CAMPO: Mensagem 4
        // POSIÇÃO: 140 a 179
        // PICTURE: 9(40)
        $arquivo = str_pad($arquivo, 179);

        // CAMPO: Uso Exclusivo do Banco
        // POSIÇÃO: 180 a 199
        // PICTURE: X(20)
        $arquivo = str_pad($arquivo, 199);
        
        // CAMPO: Uso Exclusivo do Banco  DATA LIMITE PARA PAGAMENTO
        // POSIÇÃO: 200 a 207
        // PICTURE: 9(08)
        $arquivo = str_pad($arquivo, 207, '0');
        
        // CAMPO: Uso Exclusivo do Banco
        // POSIÇÃO: 208 a 210
        // PICTURE: 9(03)
        $arquivo = str_pad($arquivo, 210, '0');

        // CAMPO: Uso Exclusivo do Banco
        // POSIÇÃO: 211 a 215
        // PICTURE: X(05)
        $arquivo = str_pad($arquivo, 215, '0');
        
        // CAMPO: Uso Exclusivo do Banco
        // POSIÇÃO: 216 a 216
        // PICTURE: 9(01)
        $arquivo .= self::preenche_brancos(' ', 1);
        
        // CAMPO: Uso Exclusivo do Banco
        // POSIÇÃO: 217 a 228
        // PICTURE: X(12)
        $arquivo = str_pad($arquivo, 228, '0');
        
        // CAMPO: Uso Exclusivo do Banco
        // POSIÇÃO: 229 a 229
        // PICTURE: X(01)
        $arquivo .= self::preenche_brancos(' ', 1);
        
        // CAMPO: Uso Exclusivo do Banco
        // POSIÇÃO: 230 a 230
        // PICTURE: X(01)
        $arquivo .= self::preenche_brancos(' ', 1);
        
        // CAMPO: Uso Exclusivo do Banco
        // POSIÇÃO: 231 a 231
        // PICTURE: 9(1)
        $arquivo = str_pad($arquivo,231, '0');
        
        // CAMPO: Uso Exclusivo do Banco
        // POSIÇÃO: 232 a 240
        // PICTURE: X(9)
        $arquivo = str_pad($arquivo, 240) . "\r\n";

        //Grava a variavel arquivo no arquivo texto
        fprintf($file, "%s", $arquivo);
        fclose($file);
    }
    
    //#################################################################//
    //#################  Registro Trailler de Lote ####################//
    //#################################################################//
    public function GeraTraillerLote($caminho, $nmarquivo, $nrorg, $cdbanco, $contreg = NULL){
        $this->qtdRegistros++;
        if (!is_dir($caminho))
            mkdir($caminho, "0777", true);
        $nmarquivo = $caminho.$nmarquivo;
        $file = fopen($nmarquivo, "a+");

        // CAMPO: Código do Banco
        // POSIÇÃO: 001 a 003
        // PICTURE: 9(3)
        $arquivo = self::CODIGO_BANCO;

        // CAMPO: Lote de Serviço
        // POSIÇÃO: 004 a 007
        // PICTURE: 9(4)
        $arquivo .= self::NUMERO_LOTE;

        // CAMPO: Identificação do Arquivo
        // POSIÇÃO: 008 a 008
        // PICTURE: 9(1)
        $arquivo .= self::TIPO_DE_REGISTRO_TRAILLER_LOTE;

        // CAMPO: Uso exclusivo FEBRABAN
        // POSIÇÃO: 009 a 017
        // PICTURE: X(9)
        $arquivo = str_pad($arquivo, 17);

        // CAMPO: Quantidade de registros do arquivo
        // POSIÇÃO: 018 a 023
        // PICTURE: 9(6)
        $arquivo .= Util::campoCnabValido(str_pad($this->qtdRegistros - 1, 6, "0", STR_PAD_LEFT));
        
        // CAMPO: Quantidade de títulos em cobrança Simples
        // POSIÇÃO: 024 a 029
        // PICTURE: 9(6)
        $arquivo .= str_pad($this->qtdRegSimples , 6, "0", STR_PAD_LEFT);
        
        // CAMPO: Valor Total dos Títulos em Carteiras
        // POSIÇÃO: 030 a 046
        // PICTURE: 9(15,2)
        //$arquivo .= str_pad($this->vrTotalBoletos , 15, "0", STR_PAD_LEFT);
        $arquivo = str_pad($arquivo, 46, '0');
        
        // CAMPO: Quantidade de títulos em cobrança Vinculada
        // POSIÇÃO: 047 a 052
        // PICTURE: 9(6)
        $arquivo = str_pad($arquivo, 52, '0');
        
        // CAMPO: Valor Total dos Títulos em Cobranca vinculada
        // POSIÇÃO: 053 a 069
        // PICTURE: 9(15,2)
        $arquivo = str_pad($arquivo, 69, '0');
     
        // CAMPO: Quantidade de títulos em cobrança Caucionada
        // POSIÇÃO: 070 a 075
        // PICTURE: 9(6)
        $arquivo = str_pad($arquivo, 75, '0');
        
        // CAMPO: Valor Total dos Títulos em Cobranca Caucionada
        // POSIÇÃO: 076 a 092
        // PICTURE: 9(15,2)
        $arquivo = str_pad($arquivo, 92, '0');
        
        // CAMPO: Quantidade de títulos em cobrança Descontada
        // POSIÇÃO: 093 a 098
        // PICTURE: 9(6)
        $arquivo = str_pad($arquivo, 98, '0');
        
        // CAMPO: Valor Total dos Títulos em Cobranca Descontada
        // POSIÇÃO: 099 a 115
        // PICTURE: 9(15,2)
        $arquivo = str_pad($arquivo, 115, '0');
        
        // CAMPO: Número do Aviso de Lançamento
        // POSIÇÃO: 116 a 123
        // PICTURE: X(8)
        $arquivo = str_pad($arquivo, 123);
        
        // CAMPO: Uso Exclusivo do Banco
        // POSIÇÃO: 124 a 240
        // PICTURE: X(117)
        $arquivo = str_pad($arquivo, 240) . "\r\n";
        
        //Grava a variavel arquivo no arquivo texto
        fprintf($file, "%s", $arquivo);
        fclose($file);
    }
    
    //#################################################################//
    //#################  Registro Trailler ############################//
    //#################################################################//
    public function GeraTrailler($caminho, $nmarquivo, $nrorg, $cdbanco, $contlote = NULL, $contreg = NULL, $cdreducont = NULL){
        $this->qtdRegistros++;
        if (!is_dir($caminho))
            mkdir($caminho, "0777", true);
        $nmarquivo = $caminho.$nmarquivo;
        $file = fopen($nmarquivo, "a+");

        // CAMPO: Código do Banco
        // POSIÇÃO: 001 a 003
        // PICTURE: 9(3)
        $arquivo = self::CODIGO_BANCO;

        // CAMPO: Lote de Serviço
        // POSIÇÃO: 004 a 007
        // PICTURE: 9(4)
        $arquivo .= self::LOTE_SERVICO_TRAILLER;

        // CAMPO: Identificação do Arquivo
        // POSIÇÃO: 008 a 008
        // PICTURE: 9(1)
        $arquivo .= self::TIPO_DE_REGISTRO_TRAILLER;

        // CAMPO: Uso exclusivo FEBRABAN
        // POSIÇÃO: 009 a 017
        // PICTURE: X(9)
        $arquivo .= self::preenche_brancos(' ', 9);

        // CAMPO: Quantidade de lotes do arquivo
        // POSIÇÃO: 018 a 023
        // PICTURE: 9(6)
        $arquivo .= Util::campoCnabValido(str_pad($contlote, 6, "0", STR_PAD_LEFT));
        
        // CAMPO: Quantidade de registros do arquivo
        // POSIÇÃO: 024 a 029
        // PICTURE: 9(6)
        $arquivo .= Util::campoCnabValido(str_pad($this->qtdRegistros, 6, "0", STR_PAD_LEFT));
        
        // CAMPO: Quantidade de contas p/ conciliação
        // POSIÇÃO: 030 a 035
        // PICTURE: 9(6)
        $arquivo = str_pad($arquivo, 35, '0');
        // CAMPO: Brancos
        // POSIÇÃO: 036 a 240
        // PICTURE: X(205)
        $arquivo .= self::preenche_brancos(' ', 205) . "\r\n";

        //Grava a variavel arquivo no arquivo texto
        fprintf($file, "%s", $arquivo);
        fclose($file);
    }
    
    /**
     * @param $valor - valor a ser alterado
     * @param $tamanho - tamanho total da string desejado
     * @return string
    */
     
    private function preenche_brancos($valor, $tamanho){
        return str_pad($valor, $tamanho);
    }
    public function geraTransacao($caminho, $nmarquivo,$nrorg, $cdempresa, $cdcartcobbol, $cdagencia, $cdcontcorr, $cdfilial,
                                           $nrlanbolrec, $vrpemobrec, $idimprboleto, $cdnosnumrec, $dtvenbolrec, $cdins1cobbol,
                                           $qtdiaprotbol, $vrmordiabrec, $vrfinalbrec, $idopecnabrec, $vrpemulbrec, $idtpijurclie,
                                           $nrinsjurclie, $cdcliente, $cdins2cobbol, $contreg = NULL, $idtipcnabrec = null, $idfilialcnabrec, $cddiaprotbol = NULL, $contador = NULL,$cdreducont,$cdbanco){}

}