<?php

namespace Teknisa\FIN\Modules\ContaReceber\Services\Retorno\Banco;

abstract class RetornoCreator{

    const CODIGO_COMPENSACAO_SANTANDER = "033";
    const CODIGO_COMPENSACAO_BRADESCO  = "237";
    const CODIGO_COMPENSACAO_ITAU      = "341";
    const CODIGO_COMPENSACAO_BRASIL    = "001";
    const CODIGO_COMPENSACAO_CAIXA     = "104";
    const CODIGO_COMPENSACAO_SICOOB    = "756";
    const CODIGO_COMPENSACAO_SICREDI   = "748";
    const CODIGO_COMPENSACAO_VOTORANTIM   = "655";
    const CODIGO_COMPENSACAO_DAYCOVAL   = "707";
    const CODIGO_COMPENSACAO_BANRISUL   = "041";
    const CODIGO_COMPENSACAO_BTG        = "208";

    CONST LAYOUT_SIACC_CAIXA = 1;
    CONST LAYOUT_SIGCB_CAIXA = 2;

    public static function getBancoCnab($cdempresa, $cdbanco, $arquivo, $nrorg, $layout = false)
    {
        try
        {
            if ($cdbanco === self::CODIGO_COMPENSACAO_SANTANDER){
                return new LeitorRetornoSantander($arquivo, $cdempresa, $cdbanco, $nrorg);
            }
            elseif($cdbanco == self::CODIGO_COMPENSACAO_BRADESCO){
                return new LeitorRetornoBradesco($arquivo, $cdempresa, $cdbanco, $nrorg);
            }
            elseif($cdbanco == self::CODIGO_COMPENSACAO_ITAU){
                return new LeitorRetornoItau($arquivo, $cdempresa, $cdbanco, $nrorg);
            }
            elseif($cdbanco == self::CODIGO_COMPENSACAO_CAIXA){
                return new LeitorRetornoCaixa($arquivo, $cdempresa, $cdbanco, $nrorg);
            }
            elseif($cdbanco === self::CODIGO_COMPENSACAO_BRASIL){
                return new LeitorRetornoBrasil($arquivo, $cdempresa, $cdbanco, $nrorg);
            }
            elseif($cdbanco === self::CODIGO_COMPENSACAO_SICOOB){
                return new LeitorRetornoSicoob($arquivo, $cdempresa, $cdbanco, $nrorg);
            }
            elseif($cdbanco === self::CODIGO_COMPENSACAO_SICREDI){
                return new LeitorRetornoSicredi($arquivo, $cdempresa, $cdbanco, $nrorg);
            }
            elseif($cdbanco === self::CODIGO_COMPENSACAO_VOTORANTIM){
                return new LeitorRetornoVotorantim($arquivo, $cdempresa, $cdbanco, $nrorg);
            }
            elseif($cdbanco === self::CODIGO_COMPENSACAO_DAYCOVAL){
                return new LeitorRetornoDaycoval($arquivo, $cdempresa, $cdbanco, $nrorg);
            }
            elseif($cdbanco === self::CODIGO_COMPENSACAO_BANRISUL){
                return new LeitorRetornoBanrisul($arquivo, $cdempresa, $cdbanco, $nrorg);
            }
            elseif($cdbanco === self::CODIGO_COMPENSACAO_BTG){
                return new LeitorRetornoBtg($arquivo, $cdempresa, $cdbanco, $nrorg);
            }
            else throw new \Exception('O Códido de Compensação informado não pertece a nenhum banco reconhecido.');

        } catch (\Exception $e) {
            throw $e;
        }
    }
}