/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PRODFATOR                                                */
/* Tabela : PRODFATOR                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 31/03/2004 - WELBERT G. MOITINHA                                           */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PRODFATOR
BEFORE INSERT OR UPDATE OR DELETE
ON PRODFATOR FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPFAT := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDFATPRECO,0) <> NVL(:NEW.CDFATPRECO,0)) OR
         (NVL(:OLD.CDPRODUTO ,0) <> NVL(:NEW.CDPRODUTO ,0)) OR
         (NVL(:OLD.VRFATPRECO,0) <> NVL(:NEW.VRFATPRECO,0)) THEN
         :NEW.DTULTATUPFAT := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PRODFATOR','', 'CDFATPRECO='||:OLD.CDFATPRECO||';CDPRODUTO='||:OLD.CDPRODUTO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PRODFATOR MODIFY DTULTATUPFAT DEFAULT SYSDATE
/

