create or replace TRIGGER TRILHAUDIT_INSUMOANA
BEFORE INSERT OR UPDATE OR DELETE
ON INSUMOANA FOR EACH ROW
DECLARE
   V_NRSEQTRILHA  NUMBER(10);
   V_NMPRODUTO    VARCHAR2(50);
   V_NMINSPECAO   VARCHAR2(200);
   V_ITEMALTERADO VARCHAR2(1000);
   V_NEWTIPOINSU  VARCHAR2(50);
   V_OLDTIPOINSU  VARCHAR2(50);
   V_CDOPERADOR   VARCHAR2(12);
   V_CLIENT_INFO  VARCHAR2(64);
   V_CDARVINSPEC  VARCHAR2(50);
   V_MAXNVINSPEC  NUMBER;
   V_NMANALISE    VARCHAR2(50);
   V_DSREMOTEADDR VARCHAR2(15);
   V_DSREMOTEHOST VARCHAR2(15);
   V_DSSERVERRDM  VARCHAR2(20);
   V_DSSERVMETHOD VARCHAR2(30);
   V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_ITEMALTERADO := '';
   V_CDARVINSPEC  := '';
   V_NMANALISE    := '';
   
   --NMUSUARIO(V_NMOPERADOR);
   --DBMS_APPLICATION_INFO.READ_CLIENT_INFO(V_CLIENT_INFO);
   --V_CDOPERADOR := SUBSTR(V_CLIENT_INFO,45,12);

   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   V_CDOPERADOR := V_DSREMOTEOPER;
   --RAISE_APPLICATION_ERROR(-20405,V_NMOPERADOR||'***'||V_CDOPERADOR||'***'||V_DSREMOTEOPER, TRUE);

   IF INSERTING THEN

      BEGIN
         SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
           INTO V_NRSEQTRILHA
           FROM TRILHAUDIT;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
         V_NRSEQTRILHA := 0;
      END;
      
      BEGIN
         SELECT NMPRODUTO
           INTO V_NMPRODUTO
           FROM PRODUTO
          WHERE CDPRODUTO = :NEW.CDPRODINSU;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
         V_NMPRODUTO := '';
      END;

      BEGIN
         SELECT NMINSPECAO
           INTO V_NMINSPECAO
           FROM INSPECAO
          WHERE CDINSPECAO = :NEW.CDINSPECAO;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
         V_NMINSPECAO := NULL;
      END;

      BEGIN
         SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
           INTO V_CDARVINSPEC, V_MAXNVINSPEC
           FROM INSPECAO
          WHERE IDORIGINSPEC IN 'ANA'
            AND CDINSPECAO = :NEW.CDINSPECAO
          GROUP BY CDARVINSPEC;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
         V_CDARVINSPEC := NULL;
         V_MAXNVINSPEC := NULL;
      END;

      BEGIN
         SELECT NMINSPECAO
           INTO V_NMANALISE
           FROM INSPECAO
          WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
            AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
         V_NMANALISE := NULL;
      END;

      V_ITEMALTERADO :=  'Insero de Reagente ' || V_NMPRODUTO || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;
      
      INSERT INTO TRILHAUDIT
         (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
      VALUES
         (V_NRSEQTRILHA, :NEW.CDPRODUTO, :NEW.IDPROCPROD, 'I', SYSDATE, NULL, 'Insero de Reagente', V_CDOPERADOR, V_ITEMALTERADO);
   
   ELSIF DELETING THEN
      BEGIN
         SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
           INTO V_NRSEQTRILHA
           FROM TRILHAUDIT;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
         V_NRSEQTRILHA := 0;
      END;
      
      BEGIN
         SELECT NMPRODUTO
           INTO V_NMPRODUTO
           FROM PRODUTO
          WHERE CDPRODUTO = :OLD.CDPRODINSU;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
         V_NMPRODUTO := '';
      END;

      BEGIN
         SELECT NMINSPECAO
           INTO V_NMINSPECAO
           FROM INSPECAO
          WHERE CDINSPECAO = :NEW.CDINSPECAO;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
         V_NMINSPECAO := NULL;
      END;

      BEGIN
         SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
           INTO V_CDARVINSPEC, V_MAXNVINSPEC
           FROM INSPECAO
          WHERE IDORIGINSPEC IN 'ANA'
            AND CDINSPECAO = :NEW.CDINSPECAO
          GROUP BY CDARVINSPEC;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
         V_CDARVINSPEC := NULL;
         V_MAXNVINSPEC := NULL;
      END;

      BEGIN
         SELECT NMINSPECAO
           INTO V_NMANALISE
           FROM INSPECAO
          WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
            AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
         V_NMANALISE := NULL;
      END;

      V_ITEMALTERADO :=  'Insero de Reagente ' || V_NMPRODUTO || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;

      INSERT INTO TRILHAUDIT
         (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
      VALUES
         (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDPROCPROD, 'E', SYSDATE, NULL, 'Excluso de Reagente ' || V_NMPRODUTO, V_CDOPERADOR, V_ITEMALTERADO);
   ELSIF UPDATING THEN
      IF (:NEW.NRSEQINSUMOANA <> :OLD.NRSEQINSUMOANA) THEN
         BEGIN
            SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
              INTO V_NRSEQTRILHA
              FROM TRILHAUDIT;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NRSEQTRILHA := 0;
         END;

         BEGIN
            SELECT NMPRODUTO
              INTO V_NMPRODUTO
              FROM PRODUTO
             WHERE CDPRODUTO = :OLD.CDPRODINSU;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMPRODUTO := '';
         END;


         BEGIN
            SELECT NMINSPECAO
              INTO V_NMINSPECAO
              FROM INSPECAO
             WHERE CDINSPECAO = :NEW.CDINSPECAO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMINSPECAO := NULL;
         END;

         BEGIN
            SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
              INTO V_CDARVINSPEC, V_MAXNVINSPEC
              FROM INSPECAO
             WHERE IDORIGINSPEC IN 'ANA'
               AND CDINSPECAO = :NEW.CDINSPECAO
             GROUP BY CDARVINSPEC;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_CDARVINSPEC := NULL;
            V_MAXNVINSPEC := NULL;
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMANALISE
              FROM INSPECAO
             WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
               AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMANALISE := NULL;
         END;

         V_ITEMALTERADO :=  'Chave Primria Sequencial ' || V_NMPRODUTO || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;

         INSERT INTO TRILHAUDIT
            (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
         VALUES
            (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDPROCPROD, 'A', SYSDATE, :OLD.NRSEQINSUMOANA, :NEW.NRSEQINSUMOANA, V_CDOPERADOR, V_ITEMALTERADO);
      END IF;   
      
      IF (:NEW.CDPRODUTO <> :OLD.CDPRODUTO) THEN
         BEGIN
            SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
              INTO V_NRSEQTRILHA
              FROM TRILHAUDIT;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NRSEQTRILHA := 0;
         END;

         BEGIN
            SELECT NMPRODUTO
              INTO V_NMPRODUTO
              FROM PRODUTO
             WHERE CDPRODUTO = :OLD.CDPRODINSU;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMPRODUTO := '';
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMINSPECAO
              FROM INSPECAO
             WHERE CDINSPECAO = :NEW.CDINSPECAO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMINSPECAO := NULL;
         END;

         BEGIN
            SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
              INTO V_CDARVINSPEC, V_MAXNVINSPEC
              FROM INSPECAO
             WHERE IDORIGINSPEC IN 'ANA'
               AND CDINSPECAO = :NEW.CDINSPECAO
             GROUP BY CDARVINSPEC;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_CDARVINSPEC := NULL;
            V_MAXNVINSPEC := NULL;
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMANALISE
              FROM INSPECAO
             WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
               AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMANALISE := NULL;
         END;

         V_ITEMALTERADO :=  'Produto ' || V_NMPRODUTO || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;

         INSERT INTO TRILHAUDIT
            (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
         VALUES
            (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDPROCPROD, 'A', SYSDATE, :OLD.CDPRODUTO, :NEW.CDPRODUTO, V_CDOPERADOR, V_ITEMALTERADO);
      END IF;

      IF (:NEW.IDPROCPROD <> :OLD.IDPROCPROD) THEN
         BEGIN
            SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
              INTO V_NRSEQTRILHA
              FROM TRILHAUDIT;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NRSEQTRILHA := 0;
         END;

         BEGIN
            SELECT NMPRODUTO
              INTO V_NMPRODUTO
              FROM PRODUTO
             WHERE CDPRODUTO = :OLD.CDPRODINSU;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMPRODUTO := '';
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMINSPECAO
              FROM INSPECAO
             WHERE CDINSPECAO = :NEW.CDINSPECAO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMINSPECAO := NULL;
         END;

         BEGIN
            SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
              INTO V_CDARVINSPEC, V_MAXNVINSPEC
              FROM INSPECAO
             WHERE IDORIGINSPEC IN 'ANA'
               AND CDINSPECAO = :NEW.CDINSPECAO
             GROUP BY CDARVINSPEC;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_CDARVINSPEC := NULL;
            V_MAXNVINSPEC := NULL;
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMANALISE
              FROM INSPECAO
             WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
               AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMANALISE := NULL;
         END;

         V_ITEMALTERADO :=  'Processo do Produto ' || V_NMPRODUTO || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;

         INSERT INTO TRILHAUDIT
            (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
         VALUES
            (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDPROCPROD, 'A', SYSDATE, :OLD.IDPROCPROD, :NEW.IDPROCPROD, V_CDOPERADOR, V_ITEMALTERADO);
      END IF;
      
      IF (:NEW.CDINSPECAO <> :OLD.CDINSPECAO) THEN
         BEGIN
            SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
              INTO V_NRSEQTRILHA
              FROM TRILHAUDIT;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NRSEQTRILHA := 0;
         END;

         BEGIN
            SELECT NMPRODUTO
              INTO V_NMPRODUTO
              FROM PRODUTO
             WHERE CDPRODUTO = :OLD.CDPRODINSU;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMPRODUTO := '';
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMINSPECAO
              FROM INSPECAO
             WHERE CDINSPECAO = :NEW.CDINSPECAO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMINSPECAO := NULL;
         END;

         BEGIN
            SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
              INTO V_CDARVINSPEC, V_MAXNVINSPEC
              FROM INSPECAO
             WHERE IDORIGINSPEC IN 'ANA'
               AND CDINSPECAO = :NEW.CDINSPECAO
             GROUP BY CDARVINSPEC;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN

            V_CDARVINSPEC := NULL;
            V_MAXNVINSPEC := NULL;
         END;
         BEGIN
            SELECT NMINSPECAO
              INTO V_NMANALISE
              FROM INSPECAO
             WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
               AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMANALISE := NULL;
         END;

         V_ITEMALTERADO :=  'Inspeo do Produto ' || V_NMPRODUTO || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;

         INSERT INTO TRILHAUDIT
            (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
         VALUES
            (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDPROCPROD, 'A', SYSDATE, :OLD.CDINSPECAO, :NEW.CDINSPECAO, V_CDOPERADOR, V_ITEMALTERADO);
      END IF;

      IF (:NEW.CDPRODINSU <> :OLD.CDPRODINSU) THEN
         BEGIN
            SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
              INTO V_NRSEQTRILHA
              FROM TRILHAUDIT;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NRSEQTRILHA := 0;
         END;

         BEGIN
            SELECT NMPRODUTO
              INTO V_NMPRODUTO
              FROM PRODUTO
             WHERE CDPRODUTO = :OLD.CDPRODINSU;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMPRODUTO := '';
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMINSPECAO
              FROM INSPECAO
             WHERE CDINSPECAO = :NEW.CDINSPECAO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMINSPECAO := NULL;
         END;

         BEGIN
            SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
              INTO V_CDARVINSPEC, V_MAXNVINSPEC
              FROM INSPECAO
             WHERE IDORIGINSPEC IN 'ANA'
               AND CDINSPECAO = :NEW.CDINSPECAO
             GROUP BY CDARVINSPEC;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_CDARVINSPEC := NULL;
            V_MAXNVINSPEC := NULL;
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMANALISE
              FROM INSPECAO
             WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
               AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMANALISE := NULL;
         END;

         V_ITEMALTERADO :=  'Alterao do Reagente ' || V_NMPRODUTO || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;

         INSERT INTO TRILHAUDIT
            (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
         VALUES
            (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDPROCPROD, 'A', SYSDATE, :OLD.CDPRODINSU, :NEW.CDPRODINSU, V_CDOPERADOR, V_ITEMALTERADO);
      END IF;

      IF (:NEW.QTDEBRUTANA <> :OLD.QTDEBRUTANA) THEN
         BEGIN
            SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
              INTO V_NRSEQTRILHA
              FROM TRILHAUDIT;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NRSEQTRILHA := 0;
         END;

         BEGIN
            SELECT NMPRODUTO
              INTO V_NMPRODUTO
              FROM PRODUTO
             WHERE CDPRODUTO = :OLD.CDPRODINSU;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMPRODUTO := '';
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMINSPECAO
              FROM INSPECAO
             WHERE CDINSPECAO = :NEW.CDINSPECAO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMINSPECAO := NULL;
         END;

         BEGIN
            SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
              INTO V_CDARVINSPEC, V_MAXNVINSPEC
              FROM INSPECAO
             WHERE IDORIGINSPEC IN 'ANA'
               AND CDINSPECAO = :NEW.CDINSPECAO
             GROUP BY CDARVINSPEC;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_CDARVINSPEC := NULL;
            V_MAXNVINSPEC := NULL;
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMANALISE
              FROM INSPECAO
             WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
               AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMANALISE := NULL;
         END;

         V_ITEMALTERADO :=  'Alterao da Qt. Bruta do Reagente ' || V_NMPRODUTO || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;

         INSERT INTO TRILHAUDIT
            (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
         VALUES
            (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDPROCPROD, 'A', SYSDATE, :OLD.QTDEBRUTANA, :NEW.QTDEBRUTANA, V_CDOPERADOR, V_ITEMALTERADO);
      END IF;
      
      IF (:NEW.QTRENDANA <> :OLD.QTRENDANA) THEN
         BEGIN
            SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
              INTO V_NRSEQTRILHA
              FROM TRILHAUDIT;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NRSEQTRILHA := 0;
         END;

         BEGIN
            SELECT NMPRODUTO
              INTO V_NMPRODUTO
              FROM PRODUTO
             WHERE CDPRODUTO = :OLD.CDPRODINSU;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMPRODUTO := '';
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMINSPECAO
              FROM INSPECAO
             WHERE CDINSPECAO = :NEW.CDINSPECAO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMINSPECAO := NULL;
         END;

         BEGIN
            SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
              INTO V_CDARVINSPEC, V_MAXNVINSPEC
              FROM INSPECAO
             WHERE IDORIGINSPEC IN 'ANA'
               AND CDINSPECAO = :NEW.CDINSPECAO
             GROUP BY CDARVINSPEC;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_CDARVINSPEC := NULL;
            V_MAXNVINSPEC := NULL;
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMANALISE
              FROM INSPECAO
             WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
               AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMANALISE := NULL;
         END;

         V_ITEMALTERADO :=  'Alterao do Rendimento do Reagente ' || V_NMPRODUTO || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;

         INSERT INTO TRILHAUDIT
            (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
         VALUES
            (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDPROCPROD, 'A', SYSDATE, :OLD.QTRENDANA, :NEW.QTRENDANA, V_CDOPERADOR, V_ITEMALTERADO);
      END IF;

      IF (:NEW.QTDELIQANA <> :OLD.QTDELIQANA) THEN
         BEGIN
            SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
              INTO V_NRSEQTRILHA
              FROM TRILHAUDIT;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NRSEQTRILHA := 0;
         END;

         BEGIN
            SELECT NMPRODUTO
              INTO V_NMPRODUTO
              FROM PRODUTO
             WHERE CDPRODUTO = :OLD.CDPRODINSU;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMPRODUTO := '';
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMINSPECAO
              FROM INSPECAO
             WHERE CDINSPECAO = :NEW.CDINSPECAO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMINSPECAO := NULL;
         END;

         BEGIN
            SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
              INTO V_CDARVINSPEC, V_MAXNVINSPEC
              FROM INSPECAO
             WHERE IDORIGINSPEC IN 'ANA'
               AND CDINSPECAO = :NEW.CDINSPECAO
             GROUP BY CDARVINSPEC;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_CDARVINSPEC := NULL;
            V_MAXNVINSPEC := NULL;
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMANALISE
              FROM INSPECAO
             WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
               AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMANALISE := NULL;
         END;

         V_ITEMALTERADO :=  'Alterao da Qt. Lquida do Reagente ' || V_NMPRODUTO || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;

         INSERT INTO TRILHAUDIT
            (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
         VALUES
            (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDPROCPROD, 'A', SYSDATE, :OLD.QTDELIQANA, :NEW.QTDELIQANA, V_CDOPERADOR, V_ITEMALTERADO);
      END IF;  
      
      IF (:NEW.CDTIPOINSU <> :OLD.CDTIPOINSU) THEN
         BEGIN
            SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
              INTO V_NRSEQTRILHA
              FROM TRILHAUDIT;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NRSEQTRILHA := 0;
         END;

         BEGIN
            SELECT NMTIPOINSU
              INTO V_NEWTIPOINSU
              FROM TIPOINSU
             WHERE CDTIPOINSU = :NEW.CDTIPOINSU;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NEWTIPOINSU := '';
         END;

         BEGIN
            SELECT NMTIPOINSU
              INTO V_OLDTIPOINSU
              FROM TIPOINSU
             WHERE CDTIPOINSU = :OLD.CDTIPOINSU;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_OLDTIPOINSU := '';
         END;

         BEGIN
            SELECT NMPRODUTO
              INTO V_NMPRODUTO
              FROM PRODUTO
             WHERE CDPRODUTO = :OLD.CDPRODINSU;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMPRODUTO := '';
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMINSPECAO
              FROM INSPECAO
             WHERE CDINSPECAO = :NEW.CDINSPECAO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMINSPECAO := NULL;
         END;

         BEGIN
            SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
              INTO V_CDARVINSPEC, V_MAXNVINSPEC
              FROM INSPECAO
             WHERE IDORIGINSPEC IN 'ANA'
               AND CDINSPECAO = :NEW.CDINSPECAO
             GROUP BY CDARVINSPEC;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_CDARVINSPEC := NULL;
            V_MAXNVINSPEC := NULL;
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMANALISE
              FROM INSPECAO
             WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
               AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMANALISE := NULL;
         END;

         V_ITEMALTERADO :=  'Alterao Tipo de Insumo do Reagente ' || V_NMPRODUTO || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;
      
         INSERT INTO TRILHAUDIT
            (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
         VALUES
            (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDPROCPROD, 'A', SYSDATE, V_OLDTIPOINSU, V_NEWTIPOINSU, V_CDOPERADOR, V_ITEMALTERADO);
      END IF;  
   END IF;
END;

/
-- VERSAO --
BEGIN ATUVEROBJ('TRILHAUDIT_INSUMOANA','6.05.xxx'); END;
/