var Pag41000_LancamentoAcerto_Controller = function(templateManager, ScreenService, ZHPromise, General){
    
    /**
     * Função responsável pelo acionamento do botão de adicionar novo lancamento
     * @Param Widget
    */
    this.novoLancamento = function(widget) {
        var widgetLancamentoForm = templateManager.container.getWidget('lancamemtoForm');
        widgetLancamentoForm.isVisible = true;
        widgetLancamentoForm.editing = true;
        templateManager.container.getWidget('gridPrincipal').currentRow = {};
        
        ScreenService.openSwipe(widgetLancamentoForm).then(function(){
            templateManager.updateTemplate();
        }, function (error) {
            ScreenService.showMessage(error.data.error);
            return;
        });
    };
    
    /**
     * Função responsável por abrir a tela de visualização dos lançamentos
     * @Param Widget
    */
    this.abreLancamentos = function(widget) {
        var widgetLancamentoForm = templateManager.container.getWidget('lancamemtoForm');
        console.log(templateManager.container.getWidget('gridPrincipal'));
       this.habilitaActions();
        
        ScreenService.openSwipe(widgetLancamentoForm).then(function(){
            templateManager.updateTemplate();
        }, function (error) {
            ScreenService.showMessage(error.data.error);
            return;
        });
    };
    
    /**
     * Função responsável por colocar a Widget em modo de edição
     * @Param Widget
    */
    this.abreEdicaoWidget = function(widget) {
        General.edit(widget);
    };
    
    /**
     * Função responsável por abrir a tela de lançamento dos lançamentos
     * @Param Widget
    */
    this.abreLancamentosDespesa = function(widget) {
        widget.newRow();
    };
    
    /**
     * Função responsável cancelar a edição do lanlamento
     * @Param Widget
    */
    this.cancelaEdiLancamento = function(widget) {
         widget.list(true);
         ScreenService.closeSwipe();
         templateManager.updateTemplate();
    };

    /**
     * Função responsável pelo controle de visualização das ações:
     * Adicionar
     * Recusar
     * Gerar Relatório
     * Aprovar
    */
    this.habilitaActions = function(){
        var widget = templateManager.container.getWidget('gridPrincipal');
        var linhas = widget.currentRow;
        
        var acoes = {
            adicionar : false,
            aprovar : false,
            recusar : false,
            excluir : false,
            editar : false,
            desaprova: false
        };
        
        acoes = this.validaActions(linhas.IDSTATUSLANC, acoes);
        var widgetLancamentoForm = templateManager.container.getWidget('despesasGrid');
        widgetLancamentoForm.actions.forEach(function(acaoWidget){
            Object.keys(acoes).forEach((item) => {
                if(acaoWidget.name === item){
                     acaoWidget.isVisible = acoes[item];
                }
            });
        });
        
    };

    /**
     * Valida Actions Situacao dos Lançamentos
     */
    this.validaActions = function(status, actions){
        
        //Habilita e desabilita todas as actions conforme o status do lançamento
        // A - Aprovar
        // P - Pendente
        // R - Recusar
        if (status == 'A') {
            actions.adicionar = false;
            actions.recusar = false;
            actions.aprovar = false;
            actions.editar = false;
            actions.excluir = false;
            actions.desaprova = true;
        }else if (status == 'R'){
            actions.adicionar = false;
            actions.editar = true;
            actions.excluir = true;
            actions.recusar = false;
            actions.aprovar = false;
            actions.desaprova = false;
        }else if (status == 'P'){
            actions.adicionar = false;
            actions.editar = true;
            actions.excluir = true;
            actions.recusar = true;
            actions.aprovar = true;
            actions.desaprova = false;
        }
        return actions;
    };
    
    /**
     * Desabilita PopUp Gerar Relatório
     * @param widget
     */
    this.desabilitaPopUp = function (widget_name){
        var widget = templateManager.container.getWidget(widget_name);
        widget.isVisible = false;
        ScreenService.closePopup(widget);
    };
    
    /**
      * Função Responsável por abrir o Fomulário de Exportação
    */
    this.abreExportacaoRElatorio = function(widget) {
        var widgetExport = templateManager.container.getWidget('exportForm');
        ScreenService.openPopup(widgetExport);
    };
    
    /**
     * Função responsável por controlar a habilitação do campo Todos Unidade e Todos Fornecedores
     * Cliente de Fornecedor 
    */
	this.habilitaCamposLista = function(widget){
	    if(widget.getField("TIPO").value() === "C"){
    	    widget.getField("NMRAZSOCFORN").isVisible = false;	
    	    widget.getField("NMRAZSOCFORN").readOnly = true;	
    	    widget.getField("NMRAZSOCCLIE").isVisible = true;
    	    widget.getField("NMRAZSOCCLIE").readOnly = false;	
	    }else {
	       widget.getField("NMRAZSOCFORN").isVisible = true;	
	       widget.getField("NMRAZSOCFORN").readOnly = false;	
    	    widget.getField("NMRAZSOCCLIE").isVisible = false;
    	    widget.getField("NMRAZSOCCLIE").readOnly = true;
	    }
	    templateManager.updateTemplate();
	};
	
	/**
     * Função responsável por controlar a habilitação de alguns campos Unidade e Centro de Custo
    */
	this.controlaHabilitacaoCampos = function(widget, campo,campoMan){
	    if(campo == 'NMEMPRESA' && widget.getField(campo).value()){
	        widget.getField(campoMan).readOnly = false;
	    }else if(campo == 'NMFILIALRECE' && widget.getField(campo).value()) {
	        widget.getField(campoMan).readOnly = false;
	    }else if(campo == 'NMEMPRESA' && !widget.getField(campo).value()) {
	        widget.getField('NMCENTCUST').readOnly = true;
	        widget.getField('NMCENTCUST').setValue("");
	        widget.getField('NMFILIALRECE').readOnly = true;
	        widget.getField('NMFILIALRECE').setValue("");
	    } else {
	        widget.getField(campoMan).readOnly = true;
	        widget.getField(campoMan).setValue("");
	    }
	    widget.getField(campoMan).setValue("");
	    widget.getField(campoMan).reload();
	    templateManager.updateTemplate();
	};
	
	/**
     * Função responsável por validar o valor informado com o valor limite do tipo de despesas
    */
	this.validaValorLimite = function(widget){
	    let valorNovaDespesa =  widget.getField("VRDESPESA");
	    let valorLimiteDespesa =  widget.getField("VRLIMITE");
	    if(parseFloat(valorNovaDespesa.value()) > parseFloat(valorLimiteDespesa.value())){
	        ScreenService.showMessage('Atenção! <br> O valor informado é maior que o valor limite da despesa.<br>');
	    }
	};
};
Configuration(function (ContextRegister){
    ContextRegister.register('Pag41000_LancamentoAcerto_Controller', Pag41000_LancamentoAcerto_Controller);
});