var Pag49000_ValidacaoDDA_Controller = function(ScreenService, templateManager,General, ZHPromise, Pag00200_RetornoPagamento_Service, ZhFilterPreferences){

    /**
     * Seta DataSource Filter
     */
    this.setDataSourceFilter = function(validacaoDDAGrid, preference){
        validacaoDDAGrid.dataSourceFilter.forEach(function(filter){
            switch(filter.name){
                case 'CDEMPRESA'    : filter.value = preference.FILTER_ROW.CDEMPRESA;
                    break;
                case 'CDBANCO'      : filter.value = preference.FILTER_ROW.CDBANCO;
                    break;
                case 'NRINSJURFORN' : filter.value = (preference.FILTER_ROW.NRINSJURFORN) ? preference.FILTER_ROW.NRINSJURFORN : null;
                    break;
                case 'DTINICIAL'    : filter.value = preference.FILTER_ROW.DTINTERVALO.start;
                    break;
                case 'DTFINAL'      : filter.value = preference.FILTER_ROW.DTINTERVALO.end;
                    break;
            }
        });
        
        this.removeFieldsClausulaWhere(validacaoDDAGrid, preference);
    };

    this.removeFieldsClausulaWhere = function(validacaoDDAGrid, preference){
        var filtrosRemoviveis = ['DTINTERVALO'];
        var dataSourceFilter = validacaoDDAGrid.dataSourceFilter;
        for (var i = dataSourceFilter.length - 1; i >= 0; i--) {
            if (filtrosRemoviveis.includes(dataSourceFilter[i].name)){
	        	dataSourceFilter.splice(i, 1);
	        }
        }
        preference.CUSTOM_FILTER_ROW = Util.clone(preference.FILTER_ROW);
        for (var key in preference.CUSTOM_FILTER_ROW) {
            if (filtrosRemoviveis.includes(key)){
                delete preference.CUSTOM_FILTER_ROW[key];
            }
        }
    };
    
    /**
     * Busca Empresa
     * @return cdempresa
     */
	this.buscaEmpresa = function (cdempresa){
        return Pag00200_RetornoPagamento_Service.buscaEmpresa(cdempresa).then(function(empresa) {
            return empresa;
        });
    };

    /**
     * Busca Filial
     * @return filial
     */
    this.buscaFilial = function (){
        return Pag00200_RetornoPagamento_Service.buscaFilial().then(function(filial) {
            return {dataset : {filial : filial}};
        });
    };
    
    /**
     * Busca Padrão Empresa
     */
    this.buscaPadraoEmpresa = function() {
        var deferred = ZHPromise.defer();
        this.buscaFilial().then(function(response_filial){
            var filial   = response_filial.dataset.filial[0];
            var cdempresa = filial.CDEMPRESA;

            this.buscaEmpresa(cdempresa).then(function (response_empresa){
                var empresa = response_empresa.dataset.empresa[0];
                deferred.resolve(empresa);
            });
        }.bind(this));
        return deferred.promise;
    };

    /**
     * Abre Filtro
     * @param widget
     */
    this.openFilter = function(widget){
        this.buscaPadraoEmpresa().then(function(empresa){
            var rowFilter = {
                'CDEMPRESA'  : empresa.CDEMPRESA,
                'NMEMPRESA'  : empresa.NMEMPRESA,
                'DTINTERVALO': {start : moment().format('DD/MM/YYYY'), end : moment().format('DD/MM/YYYY')}
            };
            ZhFilterPreferences.setOriginalFilter(widget.id, rowFilter);
            ZhFilterPreferences.openFilterWidget(widget, rowFilter);
        });
    };

};

Configuration(function (ContextRegister){
    ContextRegister.register('Pag49000_ValidacaoDDA_Controller', Pag49000_ValidacaoDDA_Controller);
});