var Rec15000_ChequeRecebidos_Controller = function(Rec15000_ChequeRecebidos_Service, ZhFilterPreferences, templateManager,ScreenService, General, ZHPromise){
    
    var mensagens = {
        valorFinal:  'Valor inicial deve ser menor ou igual ao valor final',
        chequeFinal: 'Cheque inicial deve ser maior ou igual ao cheque final.',
        favorecidoP: 'A operação não foi realizada para um ou mais cheques marcados, pois estes não possuem conta corrente do favorecido.',
        favorecidoT: 'A operação não foi realizada. Nenhum dos cheques marcados possui conta do favorecido.',
        favorecido:  'Conta corrente do favorecido deve ser informada.',
        selecioneRows: 'Selecione algum registro e tente novamente.',
        apresentacaoSucesso: 'Apresentação gerada com sucesso',
        erroBoletos: 'Operação bloqueada! O(s) cheque(s) não possuem boleto(s)',
        erroApresentacao: 'A operação não foi realizada para um ou mais cheques marcados, pois estes já estão apresentados.',
        erroDevolucao: 'A operação não foi realizada. Somente cheques apresentados podem ser devolvidos.',
        devolucaoSucesso: 'Devolução gerada com sucesso',
        situarCustodia: 'Confirma situar o(s) cheque(s) selecionado(s) em custódia?',
        retirarCustodia: 'Confirma retirada do(s) cheques(s) selecionado(s)?',
        erroSCustodia: 'A operação não foi realizada para um ou mais cheques marcados, pois estes já estão "Em custódia".',
        erroRCustodia: 'A operação não foi realizada para um ou mais cheques marcados, pois estes não estão "Em custódia".',
    	favorecidoDiferente: 'Operação bloqueada! A conta dos favorecidos é diferente.',
    	erroChequeCompensado: 'Operação bloqueada! Um ou mais cheque(s) já foram compensados.',
    	compensacaoSucesso: 'Compensação gerada com sucesso.', 
    	opBlocked: 'Operação bloqueada! O cheque já foi compensado.',
    	opBlockedBoleto: 'Operação bloqueada! O cheque possui boletos relacionados.',
    	empresa: 'Selecione uma empresa no filtro antes de adicionar.',
    	confirmDelete: 'Excluir registro?',
    	deleteBlocked: 'Operação bloqueada! O status do cheque não permite esta operação.'
    };
    
    var BKPcurrentRow;

	// Abre o form para um novo registro e inicializa valores
	this.adicionar = function(widget) {
		if(!widget.appliedFilter.FILTER_ROW.P_CDEMPRESA) ScreenService.showMessage(mensagens.empresa);
		else {
			var widgetPopup = templateManager.container.getWidget('leitor_cheque');
			widgetPopup.activate();
			widgetPopup.edit();
			ScreenService.openPopup(widgetPopup);
		}
	};
	
	this.editar = function(widget) {
		if(widget.currentRow.IDSITCHEQREC === 'C'){
			ScreenService.showMessage(mensagens.opBlocked);
		}else if(widget.currentRow.IDSITCHEQREC === 'P'){
			ScreenService.showMessage(mensagens.deleteBlocked);
		}else{
			General.widgetEdit(widget);
			BKPcurrentRow = angular.copy(widget.currentRow);
		}
	};
	
	this.excluir = function(widget) {
		var widgetBoleto = templateManager.container.getWidget('grid_boleto');
		if(widget.currentRow.IDSITCHEQREC === 'C') ScreenService.showMessage(mensagens.opBlocked);
		else {
			widgetBoleto.reload().then(function() {
				if(widgetBoleto.dataSource.data[0]) {
					ScreenService.showMessage(mensagens.opBlockedBoleto);
				}
				else {
					ScreenService.confirmMessage(ScreenService.i18n(mensagens.confirmDelete), 'question', function (success) {
						General.callRestEngine('fin_contaReceber#/deletarCheque', 'Row', widget.currentRow).then(function(Success){
							ScreenService.closeSwipe();
							widget.reload();
							widget.activate();
						}.bind(this),
						function (error) {
							if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
								ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
							} else {
								ScreenService.showMessage(error.data.error);
							}
						});
					}.bind(this));
				}
			});
		}
	};
	
	
	this.setDadosCheque = function(widget, cancel) {
		var widgetCheque = templateManager.container.getWidget('grid_cheques_recebidos');
		var widgetBoleto = widgetCheque.widgets[0];
		var codigos;
		if(widget.currentRow.CODCHEQUE && cancel === false) {
			codigos = Rec15000_ChequeRecebidos_Service.getCodLeitor(widget.currentRow.CODCHEQUE);
			widgetCheque.currentRow.NRCHEQUERECE = codigos[0];
		
		}
		ScreenService.closePopup(widget);
		widget.isVisible = false;
		widgetCheque.activate();
		widgetCheque.reload();
		widgetCheque.newRow();
		widgetCheque.currentRow.IDSITCHEQREC = 'A';
		widgetCheque.currentRow.IDTIPCHEQREC = 'P';
		var dataAtual = Rec15000_ChequeRecebidos_Service.getDataAtual();
		widgetCheque.currentRow.DTRECECHEQUE = dataAtual;
		widgetCheque.currentRow.DTVENCHEQREC = dataAtual;
		if(widget.currentRow.CODCHEQUE && cancel === false) {
			if(codigos[0]) widgetCheque.currentRow.NRCHEQUERECE = codigos[0];
			if(codigos[1]) widgetCheque.currentRow.NRCOMCHEQREC = codigos[1];
			if(codigos[2]) widgetCheque.currentRow.CDBANCHEQREC = codigos[2];
			if(codigos[3]) widgetCheque.currentRow.CDAGECHEQREC = codigos[3];
			if(codigos[4]) widgetCheque.currentRow.CDCNTCHEQREC = codigos[4];
		}
		widgetCheque.widgets[0].enabled  = false;
		widgetCheque.widgets[1].enabled  = false;
		widgetCheque.redraw();
		widgetBoleto.actions[0].isVisible = true;
		widgetBoleto.actions[3].isVisible = false;
		widgetBoleto.dataSource.name      = 'fin_contaReceber#/crud/boletreceber_relacionamentocheque';
		widgetBoleto.dataSourceFilter     = [];
		widget.currentRow				  = {};
	};

	// Abre o filtro e inicializa valores
    this.filter = function(widget) {
    	var rowFilter = {};
		rowFilter.IDTIPCHEQREC  = 'A';
		rowFilter.IDSITCHEQREC  = 'T';
		rowFilter.P_TPCONTCORR  = 'T';
		rowFilter.P_TPCDCLIENTE = 'T';
    	
    	ZhFilterPreferences.setOriginalFilter(widget.id, rowFilter);
		ZhFilterPreferences.openFilterWidget(widget, rowFilter);
	};
	
    // Altera o readOnly dos fields de acordo com tipo de seleção 
    this.setReadSelect = function(fieldParent, nameField, widget){
		var field = widget.getField(nameField);
		var value = fieldParent.value();
		
		if(value === 'L'){
			field.readOnly = false;
			field.validations.required = true;
		} else {
			var name = field.name;
			delete field.validations.required;
			field.readOnly = true;
			field.setValue('');
		}
		
		templateManager.updateTemplate();
	};
	
	// Valida que o valor do campo final é menor que o inicial
	this.validaIntervalo = function(widget, fieldName, fieldName2, apaga) {
		var field = widget.getField(fieldName);
		var field2 = widget.getField(fieldName2);
		if(field.value() && field2.value()) {
			if(parseFloat(field.value()) > parseFloat(field2.value())) {
				if(apaga === 1) field.setValue(undefined);
				else field2.setValue(undefined);
				if(field.name === 'P_VRINI' || field.name === 'P_VRFIN') ScreenService.showMessage(mensagens.valorFinal);
				else ScreenService.showMessage(mensagens.chequeFinal);
			}
	    }
	    this.setRequired(widget, fieldName, fieldName2);
	    
	};
	
	// Altera o required de um campo de acordo com outro campo
	this.setRequired = function(widget, nmf1, nmf2){
		var field1 = widget.getField(nmf1);
		var field2 = widget.getField(nmf2);
		if(field1.value() || field2.value()){
			field1.validations.required = true;
			field2.validations.required = true;
		} else {
			delete field1.validations.required;
			delete field2.validations.required;
			if (widget.currentRow.$error) {
        widget.currentRow.$error[nmf1] = [];
        widget.currentRow.$error[nmf2] = [];
      }
		}
	};
	
	// Ajusta os campos do filtro para a query
	this.ajustaFiltro = function(args) {
		var widget = templateManager.container.getWidget("grid_cheques_recebidos");
		var rowFilter = args.e.preference.FILTER_ROW;
		
		var filtro = [
			{
				"name": "P_CDEMPRESA",
				"operator": "=",
				"value": rowFilter.P_CDEMPRESA
			},
			{
				"name": "P_NRCHEINI",
				"operator": "=",
				"value": rowFilter.P_NRCHEINI || null	
			},
			{
				"name": "P_NRCHEFIN",
				"operator": "=",
				"value": rowFilter.P_NRCHEFIN || null
			},
			{
				"name": "P_VRINICHE",
				"operator": "=",
				"value": rowFilter.P_VRINI || null
			},
			{
				"name": "P_VRFINCHE",
				"operator": "=",
				"value": rowFilter.P_VRFIN || null
			},
			{
				"name": "IDTIPCHEQREC",
				"operator": "=",
				"value": rowFilter.IDTIPCHEQREC || 'A'
			},
			{
				"name": "IDSITCHEQREC",
				"operator": "=",
				"value": rowFilter.IDSITCHEQREC || 'T'
			},
			{
				"name": "P_DTVENINI",
				"operator": "=",
				"value": rowFilter.P_DTVEN.start
			},
			{
				"name": "P_DTVENFIN",
				"operator": "=",
				"value": rowFilter.P_DTVEN.end
			},
			{
				"name": "P_DTRECINI",
				"operator": "=",
				"value": rowFilter.P_DTREC.start
			},
			{
				"name": "P_DTRECFIN",
				"operator": "=",
				"value": rowFilter.P_DTREC.end
			}
		];
		
	    if (rowFilter.P_TPCDCLIENTE === 'T'){
	    	filtro.push({
				"name": "P_TPCDCLIENTE",
				"operator": "=",
				"value": rowFilter.P_TPCDCLIENTE 
			});
	    } else {
	    	filtro.push(
			{
				"name": "P_CDCLIENTE",
				"operator": "=",
				"value": concatValuesToFilter(rowFilter.P_TPCDCLIENTE, rowFilter.P_CDCLIENTE)
			});
	    }
	    if (rowFilter.P_TPCONTCORR === 'T'){
	    	filtro.push({
				"name": "P_TPCONTCORR",
				"operator": "=",
				"value": rowFilter.P_TPCONTCORR
			});
	    } else {
	    	filtro.push(
			{
				"name": "P_CONTCORR",
				"operator": "=",
				"value": concatValuesToFilter(rowFilter.P_TPCONTCORR, rowFilter.CDREDUCONT)
			});
	    }
	    
	    widget.dataSourceFilter = filtro;
	    args.e.preference.CUSTOM_FILTER_ROW = args.e.preference.FILTER_ROW;
	};
	
	this.ajustaFiltroOfCdreducont = function (args){
		var widget = templateManager.container.getWidget("grid_cheques_recebidos");
		var rowFilter = args.e.preference.FILTER_ROW;
		
		widget.getField('CDREDUCONT').dataSourceFilter[0].value = rowFilter.P_CDEMPRESA;
		widget.getField('CDREDUCONT').reload();
	};
	
	function concatValuesToFilter (selectNative, selectMultipleCodes){
		if (selectNative === 'T')
			return null;
		else {
			var codes = '_';
			selectMultipleCodes.forEach(function(code){
				codes = codes.concat(code).concat('_');
			});
			return codes;
		}
	}
	
	// Altera as mascaras de agencia e conta 
	this.setMasksConta = function(widget) {
		if(widget.currentRow.CDPICTAGEN) {
			var mascaraAgencia =  widget.currentRow.CDPICTAGEN.replace(/9/g, '*');
			widget.getField('CDAGENCIAMASK').mask.params.mask  = mascaraAgencia;
		}
		if(widget.currentRow.CDPICTCONT) {
			var mascaraConta   = widget.currentRow.CDPICTCONT.replace(/9/g, '*');
			widget.getField('CDCONTCORRMASK').mask.params.mask = mascaraConta;
		}
		widget.redraw();
	};
	
	// Altera a mascara de inscrição de acordo com o tipo(IDTPICEDCHEQ)
	this.setMaskInscricao = function(widget) {
		if(widget.currentRow.IDTPICEDCHEQ === 'J') { 
			widget.getField('NRCEDCHEQREC').mask = 
			{"type": "fix",
            "params": {
                "mask": "99.999.999/9999-99"
            }};
		}
        else if(widget.currentRow.IDTPICEDCHEQ === 'F') {
        	widget.getField('NRCEDCHEQREC').mask = 
			{"type": "fix",
            "params": {
                "mask": "999.999.999-99",
                "acceptOnlyNumbers": true
            }};
        }
        else {
        	widget.getField('NRCEDCHEQREC').mask = {"type": "number", "params": {"acceptOnlyNumbers": true}};
        }
        widget.redraw();
	};
	
	// Altera o label de alguns campos de acordo com parametro tipo
	// Altera a visibilidade da action de acordo com IDSITCHEQREC da row
	this.alteraLabelCampos = function(widget, tipo) {
			widget.getField('CDBANCHEQREC').label = 'C.C. Débito / Banco';
			widget.getField('CDAGECHEQREC').label = 'Agência';
			widget.getField('CDCNTCHEQREC').label = 'Conta';
			widget.getField('CDREDUCONT').label   = 'C.C. do Favorecido';
			widget.getField('CDBANCO').label = 'Banco';
			widget.getField('CDAGENCIAMASK').label = 'Agência';
			widget.getField('CDCONTCORRMASK').label = 'Conta';
			if(widget.currentRow.IDSITCHEQREC === 'P') widget.actions[3].isVisible = true;
			else widget.actions[3].isVisible = false;
		
		widget.redraw();
	};
	
	// Gera apresentação do cheque
	this.gerarApresentacao = function(widget) {
		var rows = widget.getParent().getCheckedRows();
		if(!rows[0])ScreenService.showMessage(mensagens.selecioneRows);
		else {
			Rec15000_ChequeRecebidos_Service.verificaContaFavorecido(rows).then(function(resul) {
				var rowsToUpdate = resul[0];
				var erro = resul[1];
				if(erro === 1 || erro === 2) ScreenService.showMessage(mensagens.favorecido);
				else {
					var apresentacao = widget.currentRow;
					var obj = {
						apresentacao: apresentacao,
						dados: rowsToUpdate
					};
					var dataSet = [obj];
					General.callRestEngine('fin_contaReceber#/gerarApresentacao', 'DataSet', dataSet).then(function(Success){ 
						this.closePopup('FORMAPRESENTACAO', 'grid_cheques_recebidos');
						if(Success.dataset.gerarApresentacao.erroStatus[0] === true) {
							ScreenService.showMessage(mensagens.erroApresentacao);
						}
						ScreenService.goBack();
						ScreenService.showMessage(mensagens.apresentacaoSucesso);
						ScreenService.closePopup();
						widget.getParent().unSelectAll();
					}.bind(this),
					function(callback){
						ScreenService.showMessage(callback.data.error);
					});
				}
			}.bind(this));
		}
	};
	
	// Gera devolução do cheque
	this.gerarDevolucao = function(widget) {
		if(widget.getParent().getCheckedRows().filter(function (filter){
			return filter.IDSITCHEQREC !== 'P';
		}).length === widget.getParent().getCheckedRows().length) ScreenService.showMessage(mensagens.erroDevolucao);
		else {
			var apresentacao = widget.currentRow;
			var obj = {
				apresentacao: apresentacao,
				dados: widget.getParent().getCheckedRows().filter(function (filter){
							return filter.IDSITCHEQREC === 'P';
						})
			};
			var dataSet = [obj];
			General.callRestEngine('fin_contaReceber#/gerarDevolucao', 'DataSet', dataSet).then(function(Success){
				this.closePopup('FORMDEVOLUCAO', 'grid_cheques_recebidos');
				ScreenService.goBack();
				ScreenService.showMessage(mensagens.devolucaoSucesso);
				ScreenService.closePopup();
			}.bind(this),
			function(callback){
				ScreenService.showMessage(callback.data.error);
			});
		}
	};
	
	// Gera compensação do cheque
	this.gerarCompensacao = function(widget) {
		if(widget.isValid()){
			var widgetGridChequesRecebidos = templateManager.container.getWidget("grid_cheques_recebidos");
			var cheques = widget.widgets[1].dataSource.data;
			var obj = {
				compensacao: widget.currentRow,
				cheques: cheques
			};
			var dataSet = [obj];
			this.alteraLabelCampos(widgetGridChequesRecebidos, false);
			General.callRestEngine('fin_contaReceber#/gerarCompensacao', 'DataSet', dataSet).then(function(Success){ 
				this.closePopup('FORMCOMPENSACAO', 'grid_cheques_recebidos');
				ScreenService.goBack();
				ScreenService.showMessage(mensagens.compensacaoSucesso);
				ScreenService.closePopup();
				widgetGridChequesRecebidos.unSelectAll();
				widgetGridChequesRecebidos.reload();
			}.bind(this),
			function(callback){
				ScreenService.showMessage(callback.data.error);
			});	
		}
	};
	
	// Altera o status do cheque para "Em Custódia" ou "A compensar" de acordo com o parametro tipo
	this.setCustodia = function(widget, tipo) {
		// tipo = B -> Situar em custódia("Em custódia")
		// tipo = A -> Retirar de custódia("A compensar")
		var confirmMessage;
		if(tipo === 'A') confirmMessage = mensagens.retirarCustodia;
		else if(tipo === 'B') confirmMessage = mensagens.situarCustodia;
		var rows = widget.getCheckedRows();
		if(!rows[0])ScreenService.showMessage(mensagens.selecioneRows);
		else {
			ScreenService.confirmMessage(ScreenService.i18n(confirmMessage), 'question', function (success) {
				Rec15000_ChequeRecebidos_Service.verificaContaFavorecido(rows).then(function(resul) {
					var rowsToUpdate = resul[0];
					var erro = resul[1];
					var obj = {
						tipo: tipo,
						dados: rowsToUpdate
					};
					if(erro === 2) ScreenService.showMessage(mensagens.favorecidoT);
					else {
						var dataSet = [obj];
						General.callRestEngine('fin_contaReceber#/setCustodia', 'DataSet', dataSet).then(function(Success){
							if(Success.dataset.setCustodia.erroStatus[0] === true) {
								if(tipo ==='B')	ScreenService.showMessage(mensagens.erroSCustodia);
								if(tipo ==='A')	ScreenService.showMessage(mensagens.erroRCustodia);
							}
							else if(erro === 1) ScreenService.showMessage(mensagens.favorecidoP);
							ScreenService.goBack();
							widget.reload();
							widget.unSelectAll();
							ScreenService.closePopup();
						}.bind(this),
						function(callback){
							ScreenService.showMessage(callback.data.error);
						});
					}
				}.bind(this));
			}.bind(this));
		}
	};
	
	// Abre e ativa a widget equivalente ao popupName
	this.openPopup = function(widget, popupName, verificaRows) {
		var rows;
		if(verificaRows) rows = widget.getCheckedRows();
		if(rows || !verificaRows) {
			var widgetPopup = templateManager.container.getWidget(popupName);
			if(popupName === 'FORMAPRESENTACAO') {
				widgetPopup.currentRow.DTAPRCHEQREC = Rec15000_ChequeRecebidos_Service.getDataAtual();
			}
			else if(popupName === 'FORMDEVOLUCAO') {
				widgetPopup.currentRow.DTDEVCHEQREC = Rec15000_ChequeRecebidos_Service.getDataAtual();
			}
			else if(popupName === 'FORMCOMPENSACAO') {
				this.openCompensacao(widget, widgetPopup);
				this.setObservacao(widgetPopup);
				widgetPopup.currentRow.IDSTATUSBREC = 'P';
				widgetPopup.currentRow.DTCOMPENSACAO = Rec15000_ChequeRecebidos_Service.getDataAtual();
			}
			if(popupName === 'FORMAPRESENTACAO' || popupName === 'FORMDEVOLUCAO') {
				ScreenService.openPopup(widgetPopup);
				widgetPopup.isVisible = true;
				widgetPopup.activate();
				widgetPopup.edit();
				widgetPopup.redraw();
			}
		}
		else {
			ScreenService.showMessage(mensagens.selecioneRows);
		}
    };
    
    // Ajusta os valores para o filtro de boleto e cheque a serem compensados e abre popup
    this.openCompensacao = function(widget, widgetPopup){
    	var rows = widget.getCheckedRows();
		if(!rows[0])ScreenService.showMessage(mensagens.selecioneRows);
		else {
			Rec15000_ChequeRecebidos_Service.verificaContaFavorecido(rows).then(function(resul) {
				var erro = resul[1];
				var cdreducont = rows[0].CDREDUCONT;
				var erroDif = false;
				var erroCompens = false;
		    	rows.forEach(function(row){
					if(row.CDREDUCONT !== cdreducont) erroDif = true;
					if(row.IDSITCHEQREC === 'C') erroCompens = true;
				});
				if(erro === 1 || erro === 2) ScreenService.showMessage(mensagens.favorecido);
				else if(erroDif === true) ScreenService.showMessage(mensagens.favorecidoDiferente);
				else if(erroCompens === true) ScreenService.showMessage(mensagens.erroChequeCompensado);
				else {
			    	var widgetBoleto = widgetPopup.widgets[0];
			    	var widgetCheque = widgetPopup.widgets[1];
			    	var cheques = [];
			    	var bancos = [];
			    	var agencias = [];
			    	var contas = [];
			    	rows.forEach(function(row){
			    		cheques.splice(cheques.length, 1, row.NRCHEQUERECE);
			    		bancos.splice(bancos.length, 1, row.CDBANCHEQREC);
			    		agencias.splice(agencias.length, 1, row.CDAGECHEQREC);
			    		contas.splice(contas.length, 1, row.CDCNTCHEQREC);
			    	});
			    	widgetBoleto.dataSourceFilter[0].value = cheques;
			    	widgetBoleto.dataSourceFilter[1].value = bancos;
			    	widgetBoleto.dataSourceFilter[2].value = agencias;
			    	widgetBoleto.dataSourceFilter[3].value = contas;
			    	
			    	widgetCheque.dataSourceFilter[0].value = cheques;
			    	widgetCheque.dataSourceFilter[1].value = bancos;
			    	widgetCheque.dataSourceFilter[2].value = agencias;
			    	widgetCheque.dataSourceFilter[3].value = contas;
			    	
			    	widgetBoleto.reload().then(function() {
			    		if(!widgetBoleto.dataSource.data[0]) {
							ScreenService.showMessage(mensagens.erroBoletos);
							ScreenService.goBack();
							ScreenService.closePopup();
			    		}
			    		else {
							ScreenService.openPopup(widgetPopup);
							widgetPopup.isVisible = true;
							widgetPopup.activate();
							widgetPopup.edit();
							widgetPopup.redraw();
			    			widgetCheque.reload();
			    		}
			    	});
				}
			});
		}
    };
    
    // Define o texto do campo obs
    this.setObservacao = function(widget) {
    	widget.currentRow.OBS = 'Atenção! Todos os cheques dos boletos abaixo, serão compensados.'; 
    };
    
    // Fecha a widget equivalente ao popupName
    // Abre e ativa a widget equivalente ao widgetName
    this.closePopup = function(popupName, widgetName) {
    	var widget = templateManager.container.getWidget(popupName);
        widget.currentRow = {};
        var widgetActivate = templateManager.container.getWidget(widgetName);
        ScreenService.closePopup(widget);
		ScreenService.goBack();
        widgetActivate.activate();
        widgetActivate.reload();
        widget.isVisible = false;
    };
	
	// Salva um novo cheque recebido
	this.save = function(widget) {
		if(widget.isValid()) {
			var widgetBoleto = templateManager.container.getWidget('grid_boleto');
			widgetBoleto.reload().then(function() {
				if(widgetBoleto.dataSource.data[0] && parseFloat(widget.currentRow.VRCHEQUERECE) != parseFloat(BKPcurrentRow.VRCHEQUERECE)) {
					ScreenService.showMessage(mensagens.opBlockedBoleto);
				}else {
					if (parseFloat(widget.currentRow.VRCHEQUERECE) <= 0){
						ScreenService.showMessage("O valor do cheque deve ser maior que 0");
					} else {
						widget.currentRow.CDEMPRESA    = widget.appliedFilter.FILTER_ROW.P_CDEMPRESA;
						if(!widget.currentRow.NMCEDCHEQREC) widget.currentRow.NMCEDCHEQREC = widget.currentRow.NMRAZSOCCLIE.substring(0,40);
						if(!widget.currentRow.NRCEDCHEQREC && widget.currentRow.IDTIPCHEQREC === 'P') {
							widget.currentRow.NRCEDCHEQREC = widget.currentRow.NRINSJURCLIE;
							widget.currentRow.IDTPICEDCHEQ = changeIdtpicedcheqValue(widget);
						}
						if(widget.currentRow.NMCEDCHEQREC && !widget.currentRow.IDTPICEDCHEQ) widget.currentRow.IDTPICEDCHEQ = changeIdtpicedcheqValue(widget); 
						General.saveCrud(widget).then(function(Success){
							var widgetBoleto =  templateManager.container.getWidget('grid_boleto');
							widgetBoleto.dataSource.name = 'fin_contaReceber#/crud/boletreceber_tprecboleto_cliente';
							widgetBoleto.dataSourceFilter = [
			                    {
			                        "name": "NRCHEQUE",
			                        "operator": "=",
			                        "value": General.getFieldValue('NRCHEQUERECE', 'grid_cheques_recebidos')
			                    },
			                    {
			                        "name": "CDBANCO",
			                        "operator": "=",
			                        "value": General.getFieldValue('CDBANCHEQREC', 'grid_cheques_recebidos')
			                    },
			                    {
			                        "name": "CDAGENCIA",
			                        "operator": "=",
			                        "value": General.getFieldValue('CDAGECHEQREC', 'grid_cheques_recebidos')
			                    },
			                    {
			                        "name": "CDCONTCORR",
			                        "operator": "=",
			                        "value": General.getFieldValue('CDCNTCHEQREC', 'grid_cheques_recebidos')
			                	}
			                ];
			                widgetBoleto.actions[2].isVisible = false;
			                widgetBoleto.actions[3].isVisible = true;
			                widgetBoleto.reload();
			                widget.reload([], false);
			                General.changeWidgetAcessibility(widget.widgets, true);
						},
						function(callback) {
							 ScreenService.showMessage(callback.data.error);
						});
					}
				}
			});
		}
	};
	
	function changeIdtpicedcheqValue (widget){
		switch (widget.currentRow.IDTPIJURCLIE){
			case "F":
				return widget.currentRow.IDTPIJURCLIE;
			case "J":
				return widget.currentRow.IDTPIJURCLIE;
			default :
				return null;
		}
	}
	
	this.openFilterBoletosCheque = function(widget) {
		// Alterar o numero da widget recebida depois
		var widgetPopup = widget.widgets[1];
		widgetPopup.isVisible = true;
		widgetPopup.activate();
		widgetPopup.edit();
		
		widgetPopup.currentRow.CDEMPRESA = widget.getParent().appliedFilter.FILTER_ROW.P_CDEMPRESA;
		widgetPopup.currentRow.CDCLIENTE = widget.getParent().currentRow.CDCLIENTE;
		widgetPopup.currentRow.TCDFILIAL = 'T';
		widgetPopup.currentRow.TCDREDUCONT = 'T';
		widgetPopup.currentRow.TCDTPBAIXAREC = 'T';
		widgetPopup.currentRow.DTVENBOLREC = '';
		widgetPopup.currentRow.DTEMISSAO   = '';
		ScreenService.openPopup(widgetPopup);
	};
	
	this.changeReadOnlyLista = function(field) {
		var widget = field.widget;
		var fieldChange;
		switch(field.name) {
			case 'TCDFILIAL':
				fieldChange = widget.getField('NMFILIAL');
				fieldChange.readOnly = (field.value() == 'T');
				if(field.value() == 'T') fieldChange.setValue('');
				break;
			case 'TCDREDUCONT':
				fieldChange = widget.getField('CDREDUCONT');
				fieldChange.readOnly = (field.value() == 'T');
				if(field.value() == 'T') fieldChange.setValue('');
				break;
			case 'TCDTPBAIXAREC':
				fieldChange = widget.getField('NMTPBAIXAREC');	
				fieldChange.readOnly = (field.value() == 'T');
				if(field.value() == 'T') fieldChange.setValue('');
				break;
		}
	};
	
	this.cancelar = function(args) {
		var widgetBoleto = args.owner.widget.widgets[0];
        this.alteraLabelCampos(args.owner.widget, false);
		widgetBoleto.dataSourceFilter = [
            {
                "name": "NRCHEQUE",
                "operator": "=",
                "value": "@General.getFieldValue('NRCHEQUERECE', 'grid_cheques_recebidos')@"
            },
            {
                "name": "CDBANCO",
                "operator": "=",
                "value": "@General.getFieldValue('CDBANCHEQREC', 'grid_cheques_recebidos')@"
            },
            {
                "name": "CDAGENCIA",
                "operator": "=",
                "value": "@General.getFieldValue('CDAGECHEQREC', 'grid_cheques_recebidos')@"
            },
            {
                "name": "CDCONTCORR",
                "operator": "=",
                "value": "@General.getFieldValue('CDCNTCHEQREC', 'grid_cheques_recebidos')@"
            }
        ];
        General.backOrCancel(args).then(function(){
        	args.owner.widget.reload();
        	widgetBoleto.dataSource.name = 'fin_contaReceber#/crud/boletreceber_tprecboleto_cliente';
			widgetBoleto.actions[2].isVisible = false;
            widgetBoleto.actions[3].isVisible = true;
            widgetBoleto.reload();
            General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        });
	};
	
	this.cancelarFiltroBoletos = function(widget) {
		var widgetBoletos = widget.getParent();
		widgetBoletos.showCheckbox = false;
		ScreenService.closePopup(widget);
		widget.isVisible = false;
		widgetBoletos.activate();	
	};
	
	this.filtrarBoletosCheque = function(widget) {
		var widgetBoletos = templateManager.container.getWidget('grid_boleto');
		var filter = [
			{
				"name": "CDEMPRESA",
				"operator": "=",
				"value": widget.currentRow.CDEMPRESA
			},
			{
				"name": "CDCLIENTE",
				"operator": "=",
				"value": widget.currentRow.CDCLIENTE
			},
			{
				"name": "TDTVENC",
				"operator": "=",
				"value": (!widget.currentRow.DTVENBOLREC.start && !widget.currentRow.DTVENBOLREC.end) ? 'T' : ''
			},
			{
				"name": "DTVENCINI",
				"operator": "=",
				"value": widget.currentRow.DTVENBOLREC.start || ''
			},
			{
				"name": "DTVENCFIN",
				"operator": "=",
				"value": widget.currentRow.DTVENBOLREC.end || ''
			},
			{
				"name": "TNRDOC",
				"operator": "=",
				"value": (!widget.currentRow.NRDOCINI && !widget.currentRow.NRDOCFIN) ? 'T' : ''
			},
			{
				"name": "NRDOCINI",
				"operator": "=",
				"value": widget.currentRow.NRDOCINI || ''
			},
			{
				"name": "NRDOCFIN",
				"operator": "=",
				"value": widget.currentRow.NRDOCFIN || ''
			},
			{
				"name": "TDTEMISSAO",
				"operator": "=",
				"value": (!widget.currentRow.DTEMISSAO.start && !widget.currentRow.DTEMISSAO.end) ? 'T' : ''
			},
			{
				"name": "DTVENCINI",
				"operator": "=",
				"value": widget.currentRow.DTEMISSAO.start || ''
			},
			{
				"name": "DTVENCFIN",
				"operator": "=",
				"value": widget.currentRow.DTEMISSAO.end || ''
			},
			{
				"name": "TVRLIQ",
				"operator": "=",
				"value": (!widget.currentRow.VRLIQINI && !widget.currentRow.VRLIQFIN) ? 'T' : ''
			},
			{
				"name": "VRLIQINI",
				"operator": "=",
				"value": widget.currentRow.VRLIQINI || ''
			},
			{
				"name": "VRLIQFIN",
				"operator": "=",
				"value": widget.currentRow.VRLIQFIN || ''
			}
		];
		if(widget.currentRow.TCDFILIAL == 'L') filter.push({
				"name": "CDFILIEMIT",
				"operator": "IN",
				"value": widget.currentRow.CDFILIEMIT
			});
		if(widget.currentRow.TCDREDUCONT == 'L') filter.push({
				"name": "CDREDUCONT",
				"operator": "IN",
				"value": widget.currentRow.CDREDUCONT
			});
		if(widget.currentRow.TCDTPBAIXAREC == 'L') filter.push({
				"name": "CDTPBAIXAREC",
				"operator": "IN",
				"value": widget.currentRow.CDTPBAIXAREC
			});
		widgetBoletos.dataSourceFilter = filter;
		widgetBoletos.reload().then(function(success){
			widgetBoletos.showCheckbox = true;
			widgetBoletos.redraw();
			ScreenService.closePopup(widget);
			widget.isVisible = false;
			widgetBoletos.activate();
		});
	};
	
	this.openWidgetBoletosCheque = function(widget) {
		var widgetParent = templateManager.container.getWidget('grid_cheques_recebidos');
		
		if (widgetParent.currentRow.IDSITCHEQREC != 'C' && widgetParent.currentRow.IDSITCHEQREC != 'B' && widgetParent.currentRow.IDSITCHEQREC != 'R' && widgetParent.currentRow.IDSITCHEQREC != 'P'){
			
			var form_new_boleto = templateManager.container.getWidget('form_new_boleto');
			
			ScreenService.openSwipe(form_new_boleto, false).then(function (){
				form_new_boleto.fields.forEach(function(field){
					widget.getParent().fields.forEach(function(fieldParent){
						if(field.name === fieldParent.name){
							field.setValue(fieldParent.value());
						}
					});
				});
				var valor = 0;
				widget.dataSource.data.forEach(function (data){
					valor = valor + data.VRFINALBREC;
				});
				valor = form_new_boleto.getField('VRCHEQUERECE').value() - valor;
				if (valor > 0){
					form_new_boleto.getField('VRRESTANTECHEQUE').setValue(valor);
				} else {
					form_new_boleto.getField('VRRESTANTECHEQUE').setValue(0);
				}
				//form_new_boleto.edit();
				
				//form_new_boleto.formTemplate = "widget/tabbedWidget.html";
				
				templateManager.container.getWidget('grid_new_boleto').dataSource.data = [];
				//templateManager.container.getWidget('grid_new_boleto').getAction('FiltroBoletos').isVisible = false;
				
				//templateManager.container.getWidget('grid_new_boleto').template = templateManager.container.getWidget('grid_new_boleto').formTemplate;
				templateManager.updateTemplate();
			});
		}else ScreenService.showMessage(mensagens.deleteBlocked);
	};
	
	this.activateFilterOnAddBoleto = function (widget){
		//if(General.getFieldValue('NMTIPORECE', 'form_new_boleto')){
			//widget.widgets[0].getAction('FiltroBoletos').isVisible = true;
			widget.widgets[0].dataSource.name = 'fin_contaReceber#/crud/boletreceber_relacionamentocheque_filter';
		//} else {
			//widget.widgets[0].getAction('FiltroBoletos').isVisible = false;
		//}
	};
	
	this.filtrarBoletosChequeOnAdd = function(widget) {
		var widgetBoletos = templateManager.container.getWidget('grid_new_boleto');
		var filter = [
			{
				"name": "CDEMPRESA",
				"operator": "=",
				"value": widget.currentRow.CDEMPRESA
			},
			{
				"name": "CDCLIENTE",
				"operator": "=",
				"value": widget.currentRow.CDCLIENTE
			},
			{
				"name": "DTVENCINI",
				"operator": "=",
				"value": widget.currentRow.DTVENBOLREC.start || ''
			},
			{
				"name": "DTVENCFIN",
				"operator": "=",
				"value": widget.currentRow.DTVENBOLREC.end || ''
			},
			{
				"name": "TDTVENC",
				"operator": "=",
				"value": (!widget.currentRow.DTVENBOLREC.start && !widget.currentRow.DTVENBOLREC.end) ? 'T' : ''
			},
			{
				"name": "CDFILIORIG",
				"operator": "=",
				"value": concatValuesToFilter(widget.currentRow.TCDFILIAL, widget.currentRow.CDFILIEMIT)
			},
			{
				"name": "TCDFILIORIG",
				"operator": "=",
				"value": widget.currentRow.TCDFILIAL === 'T' ? 'T' : ''
			},
			{
				"name": "NRDOCINI",
				"operator": "=",
				"value": widget.currentRow.NRDOCINI || ''
			},
			{
				"name": "NRDOCFIN",
				"operator": "=",
				"value": widget.currentRow.NRDOCFIN || ''
			},
			{
				"name": "TNRDOC",
				"operator": "=",
				"value": (!widget.currentRow.NRDOCINI && !widget.currentRow.NRDOCFIN) ? 'T' : ''
			},
			{
				"name": "DTEMISINI",
				"operator": "=",
				"value": widget.currentRow.DTEMISSAO.start || '30/12/1899'
			},
			{
				"name": "DTEMISFIN",
				"operator": "=",
				"value": widget.currentRow.DTEMISSAO.end || '30/12/1899'
			},
			{
				"name": "TDTEMISSAO",
				"operator": "=",
				"value": (!widget.currentRow.DTEMISSAO.start && !widget.currentRow.DTEMISSAO.end) ? 'T' : ''
			},
			{
				"name": "CONTACORR",
				"operator": "=",
				"value": concatValuesToFilter(widget.currentRow.TCDREDUCONT, widget.currentRow.CDREDUCONT)
			},
			{
				"name": "TCONTACORR",
				"operator": "=",
				"value": widget.currentRow.TCDREDUCONT === 'T' ? 'T' : ''
			},
			{
				"name": "TPBX",
				"operator": "=",
				"value":concatValuesToFilter(widget.currentRow.TCDTPBAIXAREC, widget.currentRow.CDTPBAIXAREC)
			},
			{
				"name": "TTPBX",
				"operator": "=",
				"value": widget.currentRow.TCDTPBAIXAREC === 'T' ? 'T' : ''
			},
			{
				"name": "VRLIQINI",
				"operator": "=",
				"value": widget.currentRow.VRLIQINI || '0'
			},
			{
				"name": "VRLIQFIN",
				"operator": "=",
				"value": widget.currentRow.VRLIQFIN || '0'
			},
			{
				"name": "TVRLIQ",
				"operator": "=",
				"value": (!widget.currentRow.VRLIQINI && !widget.currentRow.VRLIQFIN) ? 'T' : ''
			}
		];
		widgetBoletos.dataSourceFilter = filter;
		widgetBoletos.reload().then(function(success){
			widgetBoletos.showCheckbox = true;
			widgetBoletos.redraw();
			ScreenService.closePopup(widget);
			widget.isVisible = false;
			widgetBoletos.activate();
		});
	};
	
	this.openFilterBoletosChequeOnAdd = function(widget) {
		// Alterar o numero da widget recebida depois
		var widgetPopup = widget.widgets[1];
		widgetPopup.isVisible = true;
		widgetPopup.activate();
		widgetPopup.edit();
		
		if(Util.isEmptyOrBlank(widgetPopup.currentRow.CDEMPRESA)){
			widgetPopup.currentRow.TCDFILIAL = 'T';
			widgetPopup.currentRow.CDFILIAL = '';
			widgetPopup.currentRow.NMFILIAL = '';
			widgetPopup.currentRow.TCDREDUCONT = 'T';
			widgetPopup.currentRow.CDREDUCONT = '';
			widgetPopup.currentRow.NMREDUCONT = '';
			widgetPopup.currentRow.TCDTPBAIXAREC = 'T';
			widgetPopup.currentRow.CDTPBAIXAREC = '';
			widgetPopup.currentRow.NMTPBAIXAREC = '';
			widgetPopup.currentRow.DTVENBOLREC = '';
			widgetPopup.currentRow.DTEMISSAO   = '';
		}
		
		widgetPopup.currentRow.CDEMPRESA = widget.getParent().getParent().getParent().appliedFilter.FILTER_ROW.P_CDEMPRESA;
		widgetPopup.currentRow.CDCLIENTE = widget.getParent().getParent().getParent().currentRow.CDCLIENTE;
		
		ScreenService.openPopup(widgetPopup);
	};
	
	this.updateRemainingValueOnCheck = function (widget){
		widget.currentRow = widget.getLastSelectedRow();
		
		if(widget.getParent().currentRow.VRRESTANTECHEQUE >= widget.currentRow.VRFINALBREC) {
			widget.currentRow.VRTPRECBOLR = widget.currentRow.VRFINALBREC;
			widget.getParent().currentRow.VRRESTANTECHEQUE = calculaValorRestanteNoCheque(widget);
		} else {
			widget.currentRow.__isSelected = false;
			widget.currentRow.VRTPRECBOLR = 0;
			widget.redraw();
			var rows = [widget.currentRow];
			widget.unSelectAll(rows);
			ScreenService.showMessage('Cheque não possui valores disponìveis para este boleto');
		}
		widget.currentRow = {};
		widget.updateCheckedRows();
	};
	
	this.updateRemainingValueOnUncheck = function (widget){
		widget.dataSource.data.forEach(function(data){
			if(data.__isSelected === false && data.VRTPRECBOLR != 0){
				data.VRTPRECBOLR = 0;
			}
		});
		widget.updateCheckedRows();
		widget.getParent().currentRow.VRRESTANTECHEQUE = calculaValorRestanteNoCheque(widget);
	};
	
	function calculaValorRestanteNoCheque (widget){
		var valorRestante = 0;
		widget.getParent().getParent().dataSource.data.forEach(function(data){
			valorRestante += formatFloat(data.VRFINALBREC);
		});
		widget.getCheckedRows().forEach(function(row){

			valorRestante += formatFloat(row.VRFINALBREC);
		});
		valorRestante = widget.getParent().currentRow.VRCHEQUERECE - valorRestante;
		return valorRestante;
	}
	
	this.setVisibilityAddBoleto = function (widget){
		var widgetParent = widget.getParent();
		if (widgetParent.currentRow.IDSITCHEQREC != 'C' && widgetParent.currentRow.IDSITCHEQREC != 'B' && widgetParent.currentRow.IDSITCHEQREC != 'R' && widgetParent.currentRow.IDSITCHEQREC != 'P'){
			widget.getAction('Adicionar').isVisible = true;
		} else {
			widget.getAction('Adicionar').isVisible = false;
		}
	};
	
	this.deleteBoleto = function (widget){
		var widgetCheque = templateManager.container.getWidget('grid_cheques_recebidos');
		if(widgetCheque.currentRow.IDSITCHEQREC === 'C') ScreenService.showMessage(mensagens.opBlocked);
		else {
			if(widgetCheque.currentRow.IDSITCHEQREC === 'R'|| widgetCheque.currentRow.IDSITCHEQREC ==='B' || widgetCheque.currentRow.IDSITCHEQREC ==='T') ScreenService.showMessage(mensagens.deleteBlocked);
			else{
				ScreenService.confirmMessage(ScreenService.i18n(mensagens.confirmDelete), 'question', function (success) {
					General.callRestEngine('fin_contaReceber#/deleteBoleto', 'Row', widget.currentRow).then(function(Success){
						ScreenService.closeSwipe();
						widget.reload();
						widget.activate();
					}.bind(this),
					function (error) {
						if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
							ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
						} else {
							ScreenService.showMessage(error.data.error);
						}
					});
				}.bind(this));
			}
		}
	};
	
	this.saveBoleto = function (args){
		var deferred = ZHPromise.defer();
		var widget = args.owner.widget;
		var widgetCheque = widget.getParent().getParent().getParent();
		var widgetBoleto = widget.getParent().getParent();
		var checkedRows;

		if (widget.getParent().isValid()) {
			if (widget.isValid()) {
				widget.currentRow.changed = true;
				checkedRows = widget.getCheckedRows().filter(function(currentRow){
					return currentRow.__isSelected === true;
				});
				checkedRows.forEach(function(currentRow){
					if(currentRow.__isSelected === true){
						currentRow.CDTIPORECE = widget.getParent().currentRow.CDTIPORECE;
						currentRow.NRSEQTPRECBO = '01';
						currentRow.NRCHEQBOLREC = widgetCheque.currentRow.NRCHEQUERECE;
						currentRow.CDBANCBOLREC = widgetCheque.currentRow.CDBANCHEQREC;
						currentRow.CDAGENBOLREC = widgetCheque.currentRow.CDAGECHEQREC;
						currentRow.CDCONTBOLREC = widgetCheque.currentRow.CDCNTCHEQREC;
					}
				});
	
				General.callRestEngine('fin_contaReceber#/saveBoleto', 'DataSet', checkedRows).then(function (response) {
					ScreenService.closePopup(templateManager.container.getActiveWidget());
					General.backOrCancel(args);
					widgetBoleto.activate();
					widgetBoleto.reload();
					widget.unSelectAll();
					deferred.resolve(response);
				}, function (error) {
					var errorMessage = 'Timeout';
	
					if (error.data) errorMessage = error.data.error;
	
					ScreenService.showMessage(errorMessage);
					deferred.reject(errorMessage);
				});
			} else deferred.reject("Preencha todos os campos corretamente!");
		} else deferred.reject("Preencha todos os campos corretamente!");

		return deferred;
			
	};
	
	this.reloadWidgets = function (widget){
		widget.reload();
		widget.widgets.forEach(function(widgetFilha){
			widgetFilha.reload();
		});
	};
	
	function formatFloat (value){
		if(typeof(value) === 'number'){
			return value;
		}

        return NaN;
	}
	
	this.changeInscrcaoMask = function (widget){
		if (widget.currentRow.NRINSJURCLIE !== undefined){
			if (widget.currentRow.NRINSJURCLIE.length === 14){
				widget.getField('NRINSJURCLIE').mask = {
						"type": "fix",
			                "params": {
			                	"mask": "99.999.999/9999-99"
			                }
					};
			}else {
				if (widget.currentRow.NRINSJURCLIE.length === 11){
					 widget.getField('NRINSJURCLIE').mask = {
							"type": "fix",
			                    "params": {
			                    	"mask": "999.999.999-99"
			                    }
						};					
				} else {
				    widget.getField('NRINSJURCLIE').mask = {"type": "number"};
				}
			}
		}
	};
	
    this.habilitaActions = function(){
        var widget = templateManager.container.getWidget('grid_cheques_recebidos');
        var checkedrows = widget.getCheckedRows();

        var actions = {
        	situacustodia  : false,
			retiracustodia : false,
			apresentacao   : false,
			devolucao      : false,
			compensacao    : false
        };

        if(checkedrows.length > 0) {
            for (var i in checkedrows){

                 if (checkedrows[i].IDSITCHEQREC == 'A') {
		            actions.situacustodia = true;
		            actions.apresentacao  = true;
		            actions.compensacao   = true;
                 }else if(checkedrows[i].IDSITCHEQREC == 'P'){
                 	actions.devolucao     = true;
		            actions.compensacao   = true;
                 }else if(checkedrows[i].IDSITCHEQREC == 'D'){
                 	actions.apresentacao  = true;
		            actions.compensacao   = true;
		            actions.situacustodia = true;
                 }else if(checkedrows[i].IDSITCHEQREC == 'B'){
                 	actions.apresentacao  = true;
		            actions.compensacao   = true;
		            actions.retiracustodia = true;
                 }else if(checkedrows[i].IDSITCHEQREC == 'C'){
                 }

            }
        }

        widget.getAction('SCUSTODIA').isVisible = actions.situacustodia;
        widget.getAction('RCUSTODIA').isVisible = actions.retiracustodia;
        widget.getAction('AP').isVisible        = actions.apresentacao;
        widget.getAction('GD').isVisible        = actions.devolucao;
        widget.getAction('GC').isVisible        = actions.compensacao;
    };
    
    this.setaMascCnpjCpfCliente = function(widget) {
	    var data = widget.dataSource.data;
	    var inscFormatada;
	    data.forEach(function(value){
	        if(value.NRINSJURCLIE.length === 14) inscFormatada = value.NRINSJURCLIE.substr(0, 2) + '.' + value.NRINSJURCLIE.substr(2, 3) + '.' + value.NRINSJURCLIE.substr(5, 3) + '/' + value.NRINSJURCLIE.substr(8, 4) + '-' + value.NRINSJURCLIE.substr(12, 2);
          else if(value.NRINSJURCLIE.length === 11) inscFormatada = value.NRINSJURCLIE.substr(0, 3) + '.' + value.NRINSJURCLIE.substr(3, 3) + '.' + value.NRINSJURCLIE.substr(6, 3) + '-' + value.NRINSJURCLIE.substr(9, 2);
          else inscFormatada = null;
          value.NRINSJURCLIE = inscFormatada?inscFormatada:value.NRINSJURCLIE;
	    });
	};
	
	this.insereParamFiltroConta = function(filtro){
		filtro.getField('CDREDUCONT').setValue('');
		if (filtro.currentRow.NMEMPRESA) {
            filtro.getField('CDREDUCONT').dataSourceFilter[0].value = filtro.currentRow.P_CDEMPRESA;
        }else {
            filtro.getField('CDREDUCONT').dataSourceFilter[0].value = null;
        }
        filtro.getField('CDREDUCONT').reload();
	};
};
/*global Configuration*/
Configuration(function (ContextRegister){
    ContextRegister.register('Rec15000_ChequeRecebidos_Controller', Rec15000_ChequeRecebidos_Controller);
});