var  lancamentoDeCredito_Controller = function(ScreenService, General, templateManager, ZHPromise, localStorageEngine, contabilizacaoController, restEngine, ZhFilterPreferences){
    
    var self = this;
    
    self.adicionaNovoLanc = function(){
        var widget = templateManager.container.getWidget('widgetLancamento');
        widget.newRow();
    };
    
    self.activeCentCust = function(){
        var widget = templateManager.container.getWidget('widgetLancamento');
        if(widget.currentRow.CDFILIAL){
            widget.currentRow.NMCENTCUST = "";
            widget.getField('NMCENTCUST').dataSourceFilter[0].value = widget.currentRow.CDFILIAL;
            widget.getField('NMCENTCUST').readOnly = false;
        }
        else{
            widget.currentRow.CDFILIAL = "";
            widget.currentRow.NMCENTCUST = "";
            widget.getField('NMCENTCUST').readOnly = true;
        }
    };
    
    self.formatFilter = function(widget, currentRowFiltro) {
        var cdfilial = currentRowFiltro.CDFILIAL;
        var dtlancsald = currentRowFiltro.DTLANCSALD;
        
        widget.dataSourceFilter.forEach(function(filtro){
            switch(filtro.name){
                case 'CDFILIAL': filtro.value = cdfilial;
                    break;
                case 'DATAINI': filtro.value = dtlancsald == null ? dtlancsald : dtlancsald.start;
					break;
				case 'DATAFIN': filtro.value = dtlancsald == null ? dtlancsald : dtlancsald.end;
				    break;
				case 'DTTODOS': filtro.value = dtlancsald == null ? 'T': null;
            }       
        });
    };
    
    self.salvarLancamento = function(widget){
        if(widget.isValid()){
            General.callRestEngine('fin_movimentacaoBancaria#/saveLancamentoCredito', 'Row', widget.currentRow).then(function(result){
                ScreenService.showMessage("Lançamento salvo com sucesso.", "success");
                ScreenService.closeSwipe();
                widget.reload();
            }).catch(function(error){
                if (contabilizacaoController.checkErrosContabilizacao(error, "Não foi possível realizar o lançamento devido a erros na contablização.")) {
                    ScreenService.showMessage(error.data.error);
                }
            });
        }
    };
    
    self.deletarLancamento = function(widget){
        ScreenService.confirmMessage('Deseja realmente excluir o Lançamento de Crédito?', 'question', function () {
            General.callRestEngine('fin_movimentacaoBancaria#/removeLancamentoCredito', 'Row', widget.currentRow).then(function(result){
                ScreenService.showMessage("Lançamento excluído com sucesso.", "success");
                ScreenService.closeSwipe();
                widget.reload();
            }).catch(function(erro){
                ScreenService.showMessage(erro.data.error);
            });
        });
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('lancamentoDeCredito_Controller', lancamentoDeCredito_Controller);
});