package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class MainPage extends PageBase {
    //Mapping
    By usernameLoginInfoTextArea = By.xpath("//div[@class='zh-header-info']");
    By reportIssueLink = By.xpath("//a[@href='/bug_report_page.php']");

    By menuPrincipal = By.xpath("//div[@class='bars']");
    //By menuPrincipal = By.id("splash");
    By displayPagamentosVencidos = By.xpath("//*[text() = 'Início']");
    By menuDocumentosFiscais = By.xpath("//span[text() = 'Documentos Fiscais']");
    By menuDocumentosFiscais_Saidas = By.xpath("//span[text() = 'Saídas']");
    By menuDocumentosFiscais_Saidas_Lancamentos = By.xpath("//span[text() = 'Lançamentos']");
    By menuDocumentosFiscais_Saidas_Lancamentos_LancamentoDeSaida = By.xpath("//span[text() = 'Lançamento de Saída']");

    By loadingWait = By.xpath("//*[@class='zh-background-loading ng-scope']//span[@class='zh-loading-icon']");

    // !!! Apuração de Imposto !!!

    By menuApuracaoDeImposto = By.xpath("//span[text() = 'Fiscal']");
    By menuApuracaoDeImposto_Imposto = By.xpath("//span[text() = 'Imposto']");
    By menuApuracaoDeImposto_Imposto_Apuracao = By.xpath("//span[text() = 'Apuração de Imposto']");


    //Actions
    public String retornaUsernameDasInformacoesDeLogin(){
        return getText(usernameLoginInfoTextArea);
    }

    public void clicarEmReportIssue(){
        click(reportIssueLink);
    }

    public void clicarEmMenuPrincipal(){
       // waitForElement(displayPagamentosVencidos);
       // waitForElement(displayPagamentosVencidos);
        waitForElement(usernameLoginInfoTextArea);
        click(menuPrincipal);
    }

    public void clicarEmDocumentosFiscais(){
        click(menuDocumentosFiscais);
    }

    public void clicarEmDocumentosFiscaisSaidas(){
        click(menuDocumentosFiscais_Saidas);
    }

    public void clicarEmDocumentosFiscaisSaidasLancamentos(){
        click(menuDocumentosFiscais_Saidas_Lancamentos);
    }

    public void clicarEmDocumentosFiscaisSaidasLancamentosLancamentoDeSaida(){
        click(menuDocumentosFiscais_Saidas_Lancamentos_LancamentoDeSaida);
    }

    // !!! Tela - Apuração de Imposto !!!

    public void clicarEmApuracaoDeImposto() { click(menuApuracaoDeImposto); }
    public void clicarApuracaoDeImpostoImposto() { click(menuApuracaoDeImposto_Imposto); }
    public void clicarApuracaoDeImpostoImpostoApuracao() { click(menuApuracaoDeImposto_Imposto_Apuracao); }

    //


    // !!! Navegação Parametro Contabil !!!
    By MenuPrincipalX = By.xpath("//div[@class='bars']");
    By Parametrizacao = By.xpath("//span[@class='menu-title ng-binding has-submenu'][text() = 'Parametrização']");
    By Contabil = By.cssSelector("body > span > section > section > div.default-window > section.something-else > div > aside > div:nth-child(3) > nav > ul > li:nth-child(1) > ul > li:nth-child(11) > ul > li:nth-child(9) > span > span.menu-title.ng-binding.has-submenu");
    By ParametroContabil = By.xpath("//span[@class='menu-title ng-binding'][text() = 'Parâmetro Contábil']");

    // !!! Navegação Parametro Financeiro !!!
    By clicarEmFinanceiro = By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[2]/nav/ul/li[1]/ul/li[11]/ul/li[8]/span/span[3]");

    public void  clicarEmParametrizacao() { waitForElement(Parametrizacao);click(Parametrizacao);}
    public void  clicarEmContabil() {waitForElement(Parametrizacao);click(Contabil);}
    public void  clicarEmParametroContabil() {click(ParametroContabil);}



    // !!! Navegação Parametro Contabil Excluir !!!
    By MenuPrincipalXEx = By.xpath("//div[@class='bars']");
    By ParametrizacaoEx = By.xpath("//span[@class='menu-title ng-binding has-submenu'][text() = 'Parametrização']");
    By ContabilEx = By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[2]/nav/ul/li[1]/ul/li[12]/ul/li[11]/span/span[3]");
    By ParametroContabilEx = By.xpath("//span[@class='menu-title ng-binding'][text() = 'Parâmetro Contábil']");


    public void  clicarEmParametrizacaoEx() { waitForElement(Parametrizacao);click(Parametrizacao);}
    public void  clicarEmContabilEx() {waitForElement(Parametrizacao);click(Contabil);}
    public void  clicarEmParametroContabilEx() {click(ParametroContabil);}

    // !!! Navegação Parametro Contabil !!!
    By ContaContabil = By.xpath("//span[@class='menu-title ng-binding'][text() = 'Conta Contábil']");
    public void  NavegarContaContabil() {

        waitForElement(ContaContabil);
        click(ContaContabil);
    }

   // Chamada Financeiro
    By Financeiro = By.xpath("//li[@class='menu-item closed sub-menu-item has-child visible']//span[@class='menu-title ng-binding has-submenu'][normalize-space()='Financeiro']");
    By ParametrosTituloPagar = By.xpath("//span[contains(text(),'Parâmetros de Títulos a Pagar')]");
    By TextoFinaceiro = By.xpath("//a[normalize-space()='Financeiro']");

    public void clicarEmMenuPrincipal2(){
        waitForElement(displayPagamentosVencidos);
        waitForElement(displayPagamentosVencidos);
        waitForElement(usernameLoginInfoTextArea);
        waitForElement(TextoFinaceiro);
    }

    public void  clicarEmFinanceiro() {waitForElement(Financeiro);click(ParametrosTituloPagar);}
    public void  clicarEmFinanceirol() {click(ParametrosTituloPagar);}


}

 