package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

import java.util.concurrent.TimeUnit;


public class ParametroContabilPage extends PageBase {

    // !!! Navegação Parametro Contabil !!!
    By MenuPrincipalX = By.xpath("//div[@class='bars']");
    By Parametrizacao = By.xpath("//span[@class='menu-title ng-binding has-submenu'][text() = 'Parametrização']");
    By Contabil = By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[2]/nav/ul/li[1]/ul/li[12]/ul/li[11]/span/span[3]");
    By ParametroContabil = By.xpath("//span[@class='menu-title ng-binding'][text() = 'Parâmetro Contábil']");
    By displayPagamentosVencidos = By.xpath("//span[text() = 'Pagamentos - Vencidos']");


    //Clicando em Adicionar Empresa
    By ClicarAdcionar = By.xpath("//*[text() = 'Adicionar']");

    public void ClicarBotaoAdicionarEmpresa() {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
    }

    //Clicando na Lupa
    By ClicarLupa = By.xpath("//div[@class=\"zh-select-multiple zh-select-autocomplete mousetrap zh-field-NMEMPRESA zh-text-align-left\"]//*[@width=\"40px\"]");

    public void ClicarLupaEmpresa() {
        click(ClicarLupa);
    }

    //Selecionando a empresa 02
    By SelecionaEmpresa = By.xpath("//*[@id=\"grid-9000\"]/div[2]/div/div[2]/div[2]/span");

    public void SelecionarEmpresa() {
        click(SelecionaEmpresa);
    }

    //Clicando em Data Inicial Contabil
    By DataInicialContabil = By.id("DTINICCONT");

    public void ClicarPeriodoContabilInicial() {
        click(DataInicialContabil);
    }

    //Selecionando mês inicial Contabil
    By MesDataInicialContabil = By.xpath("//*[text() = 'Jan']");

    public void SelecionarMesPeriodoContabilInicial() {
        click(MesDataInicialContabil);
    }

    //Clicando em Data Final Contabil
    By DataFinalContabil = By.id("DTFINACONT");

    public void ClicarPeriodoContabilFinal() {
        click(DataFinalContabil);
    }

    //Selecionando mês Final Contabil
    By MesDataFinalContabil = By.xpath("//*[text() = 'Dez']");

    public void SelecionarMesPeriodoContabilFinal() {
        click(MesDataFinalContabil);
    }

    //-------------------------------------------------//-------------------------------------------------------//
    //Clicando em Periodo de Lançamento Inicial
    By DataInicialPeriodoLancamento = By.id("DTINICLANC");

    public void ClicarPeriodoLancamentoInicial() {
        click(DataInicialPeriodoLancamento);
    }

    //Selecionando mês inicial Periodo de Lançamento
    By MesDataInicialPeriodoLancamento = By.xpath("//div[text() = 'Jan']");

    public void SelecionarMesPeriodoLancamentoInicial() {
        click(MesDataInicialPeriodoLancamento);
    }

    //Clicando em Periodo de Lançamento Final
    By DataFinalPeriodoLancamento = By.id("DTFINALANC");

    public void ClicarPeriodoLancamentoFinal() {
        click(DataFinalPeriodoLancamento);
    }

    //Selecionando mês Final Periodo de Lançamento
    By MesDataFinalPeriodoLancamento = By.xpath("//div[text() = 'Dez']");

    public void SelecionarMesPeriodoLancamentoFinal() {
        click(MesDataFinalPeriodoLancamento);
    }

    //-------------------------------------------------//-------------------------------------------------------//
    //Clicando e preenchendo Documentos Fiscais de Entrada
    By DataInicialDFE = By.id("DTINIINTCONTDFE");

    public void PreencherDocumentosFiscaisEntradaInicial(String DFEInicial) {
        click(DataInicialDFE);
        sendKeys(DataInicialDFE, DFEInicial);
    }

    By DataFinalDFE = By.id("DTFININTCONTDFE");

    public void PreencherDocumentosFiscaisEntradaFinal(String DFEFinal) {
        click(DataFinalDFE);
        sendKeys(DataFinalDFE, DFEFinal);
    }

    //-----------------------------------------------------//--------------------------------------------------//
    //Clicando e preenchendo Documentos Fiscais de Saída
    By DataInicialDFS = By.id("DTINIINTCONTDFS");

    public void PreencherDocumentosFiscaisSaidaInicial(String DFSInicial) {
        click(DataInicialDFS);
        sendKeys(DataInicialDFS, DFSInicial);
    }

    By DataFinalDFS = By.id("DTFININTCONTDFS");

    public void PreencherDocumentosFiscaisSaidaFinal(String DFSFinal) {
        click(DataFinalDFS);
        sendKeys(DataFinalDFS, DFSFinal);
    }

    //----------------------------------------------------//--------------------------------------------------//
    //Clicando e preenchendo Financeiro
    By DataInicialFINANCEIRO = By.id("DTINICCTBL");

    public void PreencherFinanceiroInicial(String FINInicial) {
        click(DataInicialFINANCEIRO);
        sendKeys(DataInicialFINANCEIRO, FINInicial);
    }

    By DataFinalFINANCEIRO = By.id("DTFINACCTBL");

    public void PreencherFinanceiroFinal(String FINFinal) {
        click(DataFinalFINANCEIRO);
        sendKeys(DataFinalFINANCEIRO, FINFinal);
    }

    //-----------------------------------------------------//-------------------------------------------------//
    //Clicando e preenchendo Fiscal
    By DataInicialFISCAL = By.id("DTINIINTCONTFIS");

    public void PreencherFiscalInicial(String FISInicial) {
        click(DataInicialFISCAL);
        sendKeys(DataInicialFISCAL, FISInicial);
    }

    By DataFinalFISCAL = By.id("DTFININTCONTFIS");

    public void PreencherFiscalFinal(String FISFinal) {
        click(DataFinalFISCAL);
        sendKeys(DataFinalFISCAL, FISFinal);
    }

    //-------------------------------------------------- -//---------------------------------------------------//
    //Clicando e preenchendo Gestão de Ativos
    By DataInicialGPA = By.id("DTINIINTCONTGPA");

    public void PreencherGestaoAtivosInicial(String GPAInicial) {
        click(DataInicialGPA);
        sendKeys(DataInicialGPA, GPAInicial);
    }

    By DataFinalGPA = By.id("DTFININTCONTGPA");

    public void PreencherGestaoAtivosFinal(String GPAFinal) {
        click(DataFinalGPA);
        sendKeys(DataFinalGPA, GPAFinal);
    }

    //-------------------------------------------------- -//---------------------------------------------------//
    //Clicando e preenchendo Venda Extemporânea
    By DataInicialVE = By.id("DTINIINTCONTVEXT");

    public void PreencherVendaExtemporaneaInicial(String VEInicial) {
        click(DataInicialVE);
        sendKeys(DataInicialVE, VEInicial);
    }

    By DataFinalVE = By.id("DTFININTCONTVEXT");

    public void PreencherVendaExtemporaneaFinal(String VEFinal) {
        click(DataFinalVE);
        sendKeys(DataFinalVE, VEFinal);
    }

    //----------------------------------------------------//----------------------------------------------------//
    //Clicar na Aba Controle de Lançamentos
    By AbaControleLancamentos = By.xpath("//*[text() = 'Controle de Lançamentos']");

    public void ClicarAbaControleDeLancamentos() {
        click(AbaControleLancamentos);
    }

    //---------------------------------------------------//-----------------------------------------------------//
    //Clicar e Selecionar Controla Centro de Custo
    By ControlaCentroCusto = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[1]/div/div/div[2]/span");
    By OpcaoControlaCentroCusto = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[1]/div/div/div[2]/ul/li[1]");

    public void SelecionarOpcaoControlaCentroCusto() {
        click(ControlaCentroCusto);
        click(OpcaoControlaCentroCusto);
    }

    //-------------------------------------------------//------------------------------------------------------//
    //Clicar e Selecionar Controla Conta Comercial
    By ControlaContaComercial = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[2]/div/div/div[2]");
    By OpcaoControlaContaComercial = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[2]/div/div/div[2]/ul/li[1]");

    public void SelecionarOpcaoContaComercial() {
        click(ControlaContaComercial);
        click(OpcaoControlaContaComercial);
    }

    //-------------------------------------------------//-----------------------------------------------------//
    //Clicar e Selecionar Utiliza Custo do Estoque na Contabilização
    By UtilizaCustoEstoqueContabilizacao = By.cssSelector("body > span > section > section > div.default-window > section.zh-swipe-container.zh-swipe-right.open > div > div:nth-child(4) > section > section > div > section > div > form > section > div > div:nth-child(3) > div > div > div.new-select.input-text.form-input-margin-bottom.mousetrap.form-control.zh-text-align-\\{\\{field\\.align.\\|\\|.\\'left\\'\\}\\}.ng-pristine.ng-untouched.ng-valid");
    By OpcaoUtilizaCustoEstoqueContabilizacao = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[3]/div/div/div[2]/ul/li[1]");

    public void SelecionarOpcaoCustoEstoqueContabilizacao() {
        click(UtilizaCustoEstoqueContabilizacao);
        click(OpcaoUtilizaCustoEstoqueContabilizacao);
    }

    //------------------------------------------------//------------------------------------------------------//
    //Clicar e Selecionar Sugere Rateio em Lançamentos Manuais
    By SugereRateio = By.cssSelector("body > span > section > section > div.default-window > section.zh-swipe-container.zh-swipe-right.open > div > div:nth-child(4) > section > section > div > section > div > form > section > div > div:nth-child(4) > div > div > div.new-select.input-text.form-input-margin-bottom.mousetrap.form-control.zh-text-align-\\{\\{field\\.align.\\|\\|.\\'left\\'\\}\\}.ng-pristine.ng-untouched.ng-valid");
    By OpcaoSugereRateio = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[4]/div/div/div[2]/ul/li[1]");

    public void SelecionarOpcaoRateioLacamentosManuais() {
        click(SugereRateio);
        click(OpcaoSugereRateio);
    }

    //-----------------------------------------------//-----------------------------------------------------//
    //Clicar e Selecionar Utiliza Saldo Societário
    By UtilizaSaldoSocietario = By.cssSelector("body > span > section > section > div.default-window > section.zh-swipe-container.zh-swipe-right.open > div > div:nth-child(4) > section > section > div > section > div > form > section > div > div:nth-child(5) > div > div > div.new-select.input-text.form-input-margin-bottom.mousetrap.form-control.zh-text-align-\\{\\{field\\.align.\\|\\|.\\'left\\'\\}\\}.ng-pristine.ng-untouched.ng-valid");
    By OpcaoUtilizaSaldoSocietario = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[5]/div/div/div[2]/ul/li[1]");

    public void SelecionarOpcaoUtilizaSadoSocietario() {
        click(UtilizaSaldoSocietario);
        click(OpcaoUtilizaSaldoSocietario);
    }

    //-----------------------------------------------//-----------------------------------------------------//
    //Clicar e Selecionar Permite Lançamentos de DB e CR na mesma Conta
    By PermiteLancamentosDBCR = By.cssSelector("body > span > section > section > div.default-window > section.zh-swipe-container.zh-swipe-right.open > div > div:nth-child(4) > section > section > div > section > div > form > section > div > div:nth-child(6) > div > div > div.new-select.input-text.form-input-margin-bottom.mousetrap.form-control.zh-text-align-\\{\\{field\\.align.\\|\\|.\\'left\\'\\}\\}.ng-pristine.ng-untouched.ng-valid");
    By OpcaoPermiteLancamentosDBCR = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[6]/div/div/div[2]/ul/li[1]");

    public void SelecionarOpcaoLancamentosDBCRConta() {
        click(PermiteLancamentosDBCR);
        click(OpcaoPermiteLancamentosDBCR);
    }

    //-----------------------------------------------//-----------------------------------------------------//
    //Clicar e Selecionar Consiste a Consolidação de Vendas (VND) de acordo com Período de Integração do DFS
    By ConsolidacaoVendasVND = By.cssSelector("body > span > section > section > div.default-window > section.zh-swipe-container.zh-swipe-right.open > div > div:nth-child(4) > section > section > div > section > div > form > section > div > div:nth-child(7) > div > div > div.new-select.input-text.form-input-margin-bottom.mousetrap.form-control.zh-text-align-\\{\\{field\\.align.\\|\\|.\\'left\\'\\}\\}.ng-pristine.ng-untouched.ng-valid");
    By OpcaoConsolidacaoVendasVND = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[7]/div/div/div[2]/ul/li[1]");

    public void SelecionarOpcaoConsolidacaoVendasDFS() {
        click(ConsolidacaoVendasVND);
        click(OpcaoConsolidacaoVendasVND);
    }

    //-----------------------------------------------//------------------------------------------------------//
    //Clicar e Selecionar Utiliza Conta "Despesa Tributária" para a partida de Diferencial de Alíquota
    By DespesaTributaria = By.cssSelector("body > span > section > section > div.default-window > section.zh-swipe-container.zh-swipe-right.open > div > div:nth-child(4) > section > section > div > section > div > form > section > div > div:nth-child(8) > div > div > div.new-select.input-text.form-input-margin-bottom.mousetrap.form-control.zh-text-align-\\{\\{field\\.align.\\|\\|.\\'left\\'\\}\\}.ng-pristine.ng-untouched.ng-valid");
    By OpcaoDespesaTributaria = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[8]/div/div/div[2]/ul/li[1]");

    public void SelecionarOpcaoUtilizaDespesaTributaria() {
        click(DespesaTributaria);
        click(OpcaoDespesaTributaria);
    }

    //-----------------------------------------------//-------------------------------------------------------//
    //Clicar e Selecionar Prioriza o Centro de Custo do Setor nas Retiradas de Estoque
    By PriorizaCentroCusto = By.cssSelector("body > span > section > section > div.default-window > section.zh-swipe-container.zh-swipe-right.open > div > div:nth-child(4) > section > section > div > section > div > form > section > div > div:nth-child(9) > div > div > div.new-select.input-text.form-input-margin-bottom.mousetrap.form-control.zh-text-align-\\{\\{field\\.align.\\|\\|.\\'left\\'\\}\\}.ng-pristine.ng-untouched.ng-valid");
    By OpcaoPriorizaCentroCusto = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[9]/div/div/div[2]/ul/li[1]");

    public void SelecionarOpcaoPriorizaCentroCustoRetiradaEstoque() {
        click(PriorizaCentroCusto);
        click(OpcaoPriorizaCentroCusto);
    }

    //-----------------------------------------------//-------------------------------------------------------//
    //Clicar e Selecionar Considera Data da Movimentação na Contabilização das Retiradas
    By ConsideraDataMovimentacao = By.cssSelector("body > span > section > section > div.default-window > section.zh-swipe-container.zh-swipe-right.open > div > div:nth-child(4) > section > section > div > section > div > form > section > div > div:nth-child(10) > div > div > div.new-select.input-text.form-input-margin-bottom.mousetrap.form-control.zh-text-align-\\{\\{field\\.align.\\|\\|.\\'left\\'\\}\\}.ng-pristine.ng-untouched.ng-valid");
    By OpcaoConsideraDataMovimentacao = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[10]/div/div/div[2]/ul/li[1]");

    public void SelecionarOpcaoDataMovimentacaoContabilizacaoRetiradas() {
        click(ConsideraDataMovimentacao);
        click(OpcaoConsideraDataMovimentacao);
    }

    //----------------------------------------------//--------------------------------------------------------//
    //Clicar e Selecionar Contabilidade por Lote Sintética na Integração com Conciliador
    By ContabilidadeLoteSintetica = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[11]/div/div/div[2]");
    By OpcaoContabilidadeLoteSintetica = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[11]/div/div/div[2]/ul/li[1]");

    public void SelecionarOpcaoContabilidadeLoteSintetica() {
        click(ContabilidadeLoteSintetica);
        click(OpcaoContabilidadeLoteSintetica);
    }

    //-----------------------------------------------//-------------------------------------------------------//
    //Clicar e Selecionar Gera estorno de lançamento contábil
    By GeraEstornoLancamentoContabil = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[12]/div/div/div[2]");
    By OpcaoGeraEstornoLancamentoContabil = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[12]/div/div/div[2]/ul/li[1]");

    public void SelecionarOpcaoGeraEstornoLancamentoContabil() {
        click(GeraEstornoLancamentoContabil);
        click(OpcaoGeraEstornoLancamentoContabil);
    }

    //-----------------------------------------------//-------------------------------------------------------//
    //Clicar e Selecionar Contabiliza Ajuste Data de Competência
    By ContabilizaAjusteCompetencia = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[13]/div/div/div[2]");
    By OpcaoContabilizaAjusteCompetenciaa = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[13]/div/div/div[2]/ul/li[1]");

    public void SelecionarOpcaoContabilizaAjusteDataCompetencia() {
        click(ContabilizaAjusteCompetencia);
        click(OpcaoContabilizaAjusteCompetenciaa);
    }

    //----------------------------------------------//--------------------------------------------------------//
    //Clicar em Salvar
    By BotaoSalvar = By.xpath("//*[text() = 'Salvar']");

    public void ClicarEmSalvar() {
        click(BotaoSalvar);
    }

    //Clicar em Salvar
    By BotaoOk = By.xpath("/html/body/span/section/section/div[2]/aside[1]/aside/section/footer/button");

    public void ClicarOk() {
        click(BotaoOk);
    }

    //By button = By.xpath("//*[text() = 'Sim']");


    By loadingWait = By.xpath("//*[@class='zh-background-loading ng-scope']//span[@class='zh-loading-icon']");

    public void AlertaUsuario() throws InterruptedException {
        this.driver.manage().timeouts().implicitlyWait(1, TimeUnit.MINUTES);
        driver.findElement(By.cssSelector("body > span > section > section > div.default-window > aside:nth-child(5) > aside > section > footer > button:nth-child(1)")).click();
        }
        
    }






