package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.ApuracaoImpostoCOFINSFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.ApuracaoImpostoCOFINSPage;
import com.javaseleniumtemplate.pages.LoginPage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.Assert;
import org.testng.annotations.Test;

public class ApuracaoImpostoCOFINS extends TestBase {

    // Objetos

    MainPage mainPage;
    LoginPage loginPage;
    MainFlows MainFlows;
    ApuracaoImpostoCOFINSFlows ApuracaoImpostoCOFINSFlows;
    ApuracaoImpostoCOFINSPage ApuracaoImpostoCOFINSPage;

    // Teste

    @Test
    public void efetuarLoginComSucesso() throws InterruptedException {

        //Objetos Instanciados

        mainPage = new MainPage();
        loginPage = new LoginPage();
        MainFlows = new MainFlows();
        ApuracaoImpostoCOFINSFlows = new ApuracaoImpostoCOFINSFlows();
        ApuracaoImpostoCOFINSPage =  new ApuracaoImpostoCOFINSPage();

        // Dados - Login

        String usuario = "operador24@AUTOMACAO_2184.com";
        String senha = "apresentacao";


        // Dados - Filtro Da Tela

        String tipodeapuracao = "Federal";
        String empresa = "HELA INGREDIENTES BRASIL";
        String imposto = "60 - PIS";


        // Dados - Inserção do Mapa de Apuração

        String nomedomapa = "Apuração de COFINS";
        String datafinal = "31/01/2021";

        // Aba - Detalhamento - Botão ( Valor Ajuste Acrescimo )

        String valorAjusteAcrescimo = "7000";
        String valorBaseCalculo = "8000";
        String NumeroDoProcesso = "1001";
        String DescricaoAjuste = "Ajuste do Mapa 50 Pis";
        String DataDebSaida = "01/01/2030";
        String NumRecibo = "101";

        // ..........Teste Da Tela..........


        // !!!! LOGIN !!!!

        loginPage.preenhcerUsuario(usuario);
        loginPage.preencherSenha(senha);
        loginPage.clicarEmLogin();


        // !!! MENU !!!

        MainFlows.navegarParaApuracaoDeImposto();


        // !!! FILTRO DE APURAÇÃO !!!

        ApuracaoImpostoCOFINSPage.clicarEmTipodeapuracao();
        ApuracaoImpostoCOFINSPage.clicarEmEmpresa();
        ApuracaoImpostoCOFINSPage.clicarEmImposto();
        ApuracaoImpostoCOFINSPage.clicarAplicarFiltro();


        // !!! ADICIONAR MAPA !!!

        ApuracaoImpostoCOFINSPage.clicarAdicionarMapa();


        // !!! CRIANDO MAPA DE APURAÇÃO !!!

        ApuracaoImpostoCOFINSPage.preencherNomedomapa(nomedomapa);
        ApuracaoImpostoCOFINSPage.clicarsalvarMapa();


        // !!! APURAÇÃO DO MAPA !!!

        ApuracaoImpostoCOFINSPage.clicarEmMapaApuracao();
        ApuracaoImpostoCOFINSPage.clicarEmAcoes();
        ApuracaoImpostoCOFINSPage.clicarEmApurar();
        ApuracaoImpostoCOFINSPage.clicarOk();


        // !!! SELECIONAR A ABA DE ( DETALHAMENTO ) !!!

        ApuracaoImpostoCOFINSPage.clicarAbaDetalhamento();


        // !!! CAMPO ( Ajuste Acréscimo - Crédito/Entradas ) !!!!

        ApuracaoImpostoCOFINSPage.clicarBotaoAjusteAcrescimo();
        ApuracaoImpostoCOFINSPage.clicarEmAdicionar();
        ApuracaoImpostoCOFINSPage.clicarEmCodigoAjuste();
        ApuracaoImpostoCOFINSPage.clicarEmTipoCredito();
        ApuracaoImpostoCOFINSPage.clicarEmRegimeApuracao();
        ApuracaoImpostoCOFINSPage.preencherValorAjusAcresc(valorAjusteAcrescimo);
        ApuracaoImpostoCOFINSPage.clicarEmSalvar();
        ApuracaoImpostoCOFINSPage.clicarEmVoltar();


        // !!! CAMPO ( Ajuste Acréscimo - Débito Base ) !!!!

        ApuracaoImpostoCOFINSPage.clicarBotaoAjusteAcrescimoDeb();
        ApuracaoImpostoCOFINSPage.clicarEmAdicionar();
        ApuracaoImpostoCOFINSPage.clicarEmAjusteBaseCalculo();
        ApuracaoImpostoCOFINSPage.clicarEmRegimeApuracao();
        ApuracaoImpostoCOFINSPage.clicarEmCSTAjusteDeb();
        ApuracaoImpostoCOFINSPage.preencherValorBaseDeCalculo(valorBaseCalculo);
        ApuracaoImpostoCOFINSPage.preencherNumeroDProcesso(NumeroDoProcesso);
        ApuracaoImpostoCOFINSPage.preencherDescricaoDoAjuste(DescricaoAjuste);
        ApuracaoImpostoCOFINSPage.preencherDataDebitoSaida(DataDebSaida);
        ApuracaoImpostoCOFINSPage.clicarContaContabil();
        ApuracaoImpostoCOFINSPage.clicarEstabelecimento();
        ApuracaoImpostoCOFINSPage.preencherNrRecibo(NumRecibo);
        ApuracaoImpostoCOFINSPage.clicarEmSalvar();
        ApuracaoImpostoCOFINSPage.clicarEmVoltar();

    }
}
