package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.ParametroContabilFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.ParametroContabilPage;
import com.javaseleniumtemplate.pages.LoginPage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.Assert;
import org.testng.annotations.Test;



public class ParametroContabil extends TestBase {

    // Objetos

    MainPage mainPage;
    LoginPage loginPage;
    MainFlows MainFlows;
    ParametroContabilFlows ParametroContabilFlows;
    ParametroContabilPage ParametroContabilPage;

    // Teste

    @Test
    public void efetuarLoginComSucesso() throws InterruptedException {

        //Objetos Instanciados

        mainPage = new MainPage();
        loginPage = new LoginPage();
        MainFlows = new MainFlows();
        ParametroContabilFlows = new ParametroContabilFlows();
        ParametroContabilPage = new ParametroContabilPage();

        // Dados - Login

        String Usuario = "operador24@AUTOMACAO_2184.com";
        String Senha = "apresentacao";

        // Dados - Períodos de Lançamentos
        String DFEInicial = "01/01/2023";
        String DFEFinal = "31/12/2023";
        String DFSInicial = "01/01/2023";
        String DFSFinal = "31/12/2023";
        String FINInicial = "01/01/2023";
        String FINFinal = "31/12/2023";
        String FISInicial = "01/01/2023";
        String FISFinal = "31/12/2023";
        String GPAInicial = "01/01/2023";
        String GPAFinal = "31/12/2023";
        String VEInicial = "01/01/2023";
        String VEFinal = "31/12/2023";

        loginPage.preenhcerUsuario(Usuario);
        loginPage.preencherSenha(Senha);
        loginPage.clicarEmLogin();

        // Aguardar Botão de Confirmação(Alerta: Sim)
        ParametroContabilPage.AlertaUsuario();


        // Navegar até Parametro Contábil
        MainFlows.navegarParaParametroContabil();

        //Adicionar Empresa
        ParametroContabilPage.ClicarBotaoAdicionarEmpresa();

        //Clica Lupa Adicionar empresa
        ParametroContabilPage.ClicarLupaEmpresa();

        // Selecionar Empresa (Aba Períodos de Lançamentos)
        ParametroContabilPage.SelecionarEmpresa();


        // Preencher  Periodo Contabil Inicial
        ParametroContabilPage.ClicarPeriodoContabilInicial();
        ParametroContabilPage.SelecionarMesPeriodoContabilInicial();

        // Preencher Periodo Contabil Final
        ParametroContabilPage.ClicarPeriodoContabilFinal();
        ParametroContabilPage.SelecionarMesPeriodoContabilFinal();

        // Preencher  Periodo de Lançamento Inicial
        ParametroContabilPage.ClicarPeriodoLancamentoInicial();
        ParametroContabilPage.SelecionarMesPeriodoLancamentoInicial();

        // Preencher Periodo Lançamento Final
        ParametroContabilPage.ClicarPeriodoLancamentoFinal();
        ParametroContabilPage.SelecionarMesPeriodoLancamentoFinal();

        // Preencher  Documentos Fiscais de Entrada Inicial
        ParametroContabilPage.PreencherDocumentosFiscaisEntradaInicial(DFEInicial);

        // Preencher  Documentos Fiscais de Entrada Final
        ParametroContabilPage.PreencherDocumentosFiscaisEntradaFinal(DFEFinal);

        // Preencher  Documentos Fiscais de Saída Inicial

        ParametroContabilPage.PreencherDocumentosFiscaisSaidaInicial(DFSInicial);

        // Preencher  Documentos Fiscais de Saída Final

        ParametroContabilPage.PreencherDocumentosFiscaisSaidaFinal(DFSFinal);

        // Preencher  Financeiro Inicial

        ParametroContabilPage.PreencherFinanceiroInicial(FINInicial);

        // Preencher  Financeiro Final

        ParametroContabilPage.PreencherFinanceiroFinal(FINFinal);

        // Preencher  Fiscal Inicial
        ParametroContabilPage.PreencherFiscalInicial(FISInicial);

        // Preencher  Fiscal Final;
        ParametroContabilPage.PreencherFiscalFinal(FISFinal);

        // Preencher  Gestão de Ativos Inicial

        ParametroContabilPage.PreencherGestaoAtivosInicial(GPAInicial);

        // Preencher  Gestão de Ativos Final

        ParametroContabilPage.PreencherGestaoAtivosFinal(GPAFinal);

        // Preencher  Venda Extemporânea Inicial

        ParametroContabilPage.PreencherVendaExtemporaneaInicial(VEInicial);

        // Preencher  Venda Extemporânea Final

        ParametroContabilPage.PreencherVendaExtemporaneaFinal(VEFinal);

        // Clicar na Aba Controle de Lançamentos
        ParametroContabilPage.ClicarAbaControleDeLancamentos();

        //Controla Centro de Custo

        ParametroContabilPage.SelecionarOpcaoControlaCentroCusto();

        // Controla Conta Comercial
        ParametroContabilPage.SelecionarOpcaoContaComercial();

        //Utiliza Custo do Estoque na Contabilização
        ParametroContabilPage.SelecionarOpcaoCustoEstoqueContabilizacao();

        //Sugere Rateio em Lançamentos Manuais
        ParametroContabilPage.SelecionarOpcaoRateioLacamentosManuais();

        //Utiliza Saldo Societário
        ParametroContabilPage.SelecionarOpcaoUtilizaSadoSocietario();

        //Permite Lançamentos de DB e CR na mesma Conta
        ParametroContabilPage.SelecionarOpcaoLancamentosDBCRConta();

        //Consiste a Consolidação de Vendas (VND) de acordo com Período de Integração do DFS
        ParametroContabilPage.SelecionarOpcaoConsolidacaoVendasDFS();

        //Utiliza Conta "Despesa Tributária" para a partida de Diferencial de Alíquota
        ParametroContabilPage.SelecionarOpcaoUtilizaDespesaTributaria();

        //Prioriza o Centro de Custo do Setor nas Retiradas de Estoque
        ParametroContabilPage.SelecionarOpcaoPriorizaCentroCustoRetiradaEstoque();

        //Considera Data da Movimentação na Contabilização das Retiradas
        ParametroContabilPage.SelecionarOpcaoDataMovimentacaoContabilizacaoRetiradas();

        //Contabilidade por Lote Sintética na Integração com Conciliador
        ParametroContabilPage.SelecionarOpcaoContabilidadeLoteSintetica();

        //Gera estorno de lançamento contábil
        ParametroContabilPage.SelecionarOpcaoGeraEstornoLancamentoContabil();


        //Clicar no Botão Salvar
        ParametroContabilPage.ClicarEmSalvar();

        //Clicar em Ok. Registro Salvo com Sucesso
        ParametroContabilPage.ClicarOk();


    }
}






