package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.ParametroContabilEditarFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.flows.ParametroContabilFlows;
import com.javaseleniumtemplate.pages.ParametroContabilEditarPage;
import com.javaseleniumtemplate.pages.LoginPage;
import com.javaseleniumtemplate.pages.MainPage;
import com.javaseleniumtemplate.pages.ParametroContabilPage;
import org.testng.Assert;
import org.testng.annotations.Test;

public class ParametroContabilEditar extends TestBase {

    // Objetos

    MainPage mainPage;
    LoginPage loginPage;
    MainFlows MainFlows;
    com.javaseleniumtemplate.flows.ParametroContabilEditarFlows ParametroContabilEditarFlows;
    com.javaseleniumtemplate.pages.ParametroContabilEditarPage ParametroContabilEditarPage;

    // Teste

    @Test
    public void efetuarLoginComSucesso() throws InterruptedException {

        //Objetos Instanciados

        mainPage = new MainPage();
        loginPage = new LoginPage();
        MainFlows = new MainFlows();
        ParametroContabilEditarFlows = new ParametroContabilEditarFlows();
        ParametroContabilEditarPage = new ParametroContabilEditarPage();

        // Dados - Login

        String Usuario = "operador24@AUTOMACAO_2184.com";
        String Senha = "apresentacao";

        // Dados - Períodos de Lançamentos
        String DFEInicial = "01/02/2023";
        String DFEFinal = "31/12/2023";
        String DFSInicial = "01/02/2023";
        String DFSFinal = "31/12/2023";
        String FINInicial = "01/02/2023";
        String FINFinal = "31/12/2023";
        String FISInicial = "01/02/2023";
        String FISFinal = "31/12/2023";
        String GPAInicial = "01/02/2023";
        String GPAFinal = "31/12/2023";
        String VEInicial = "01/02/2023";
        String VEFinal = "31/12/2023";

        loginPage.preenhcerUsuario(Usuario);
        loginPage.preencherSenha(Senha);
        loginPage.clicarEmLogin();

        // Aguardar Botão de Confirmação(Alerta: Sim)
        ParametroContabilEditarPage.AlertaUsuario();

        // Navegar até Parametro Contábil
        MainFlows.navegarParaParametroContabil();

        // Selecionar Empresa
        ParametroContabilEditarPage.SelecionaEmpresa();

        // Clicar no Botão Editar
        ParametroContabilEditarPage.ClicarBotaoEditar();

        // Preencher  Periodo Contabil Inicial
        ParametroContabilEditarPage.ClicarPeriodoContabilInicial();
        ParametroContabilEditarPage.SelecionarMesPeriodoContabilInicial();

        // Preencher Periodo Contabil Final
        ParametroContabilEditarPage.ClicarPeriodoContabilFinal();
        ParametroContabilEditarPage.SelecionarMesPeriodoContabilFinal();

        // Preencher  Periodo de Lançamento Inicial
        ParametroContabilEditarPage.ClicarPeriodoLancamentoInicial();
        ParametroContabilEditarPage.SelecionarMesPeriodoLancamentoInicial();

        // Preencher Periodo Lançamento Final
        ParametroContabilEditarPage.ClicarPeriodoLancamentoFinal();
        ParametroContabilEditarPage.SelecionarMesPeriodoLancamentoFinal();

        // Preencher  Documentos Fiscais de Entrada Inicial
        ParametroContabilEditarPage.PreencherDocumentosFiscaisEntradaInicial(DFEInicial);

        // Preencher  Documentos Fiscais de Entrada Final
        ParametroContabilEditarPage.PreencherDocumentosFiscaisEntradaFinal(DFEFinal);

        // Preencher  Documentos Fiscais de Saída Inicial

        ParametroContabilEditarPage.PreencherDocumentosFiscaisSaidaInicial(DFSInicial);

        // Preencher  Documentos Fiscais de Saída Final

        ParametroContabilEditarPage.PreencherDocumentosFiscaisSaidaFinal(DFSFinal);

        // Preencher  Financeiro Inicial

        ParametroContabilEditarPage.PreencherFinanceiroInicial(FINInicial);

        // Preencher  Financeiro Final

        ParametroContabilEditarPage.PreencherFinanceiroFinal(FINFinal);

        // Preencher  Fiscal Inicial
        ParametroContabilEditarPage.PreencherFiscalInicial(FISInicial);

        // Preencher  Fiscal Final;
        ParametroContabilEditarPage.PreencherFiscalFinal(FISFinal);

        // Preencher  Gestão de Ativos Inicial

        ParametroContabilEditarPage.PreencherGestaoAtivosInicial(GPAInicial);

        // Preencher  Gestão de Ativos Final

        ParametroContabilEditarPage.PreencherGestaoAtivosFinal(GPAFinal);

        // Preencher  Venda Extemporânea Inicial

        ParametroContabilEditarPage.PreencherVendaExtemporaneaInicial(VEInicial);

        // Preencher  Venda Extemporânea Final

        ParametroContabilEditarPage.PreencherVendaExtemporaneaFinal(VEFinal);

        //Clicar no Botão Salvar
        ParametroContabilEditarPage.ClicarEmSalvar();

        //Clicar em Ok. Registro Salvo com Sucesso
        ParametroContabilEditarPage.ClicarOk();

        // Voltar Selecionar Empresa
        ParametroContabilEditarPage.SelecionaEmpresa();

        // Clicar na Aba Controle de Lançamentos
        ParametroContabilEditarPage.ClicarAbaControleDeLancamentos();

        // Voltar Clicar no Botão Editar
        ParametroContabilEditarPage.ClicarBotaoEditar();



        //Controla Centro de Custo

         ParametroContabilEditarPage.SelecionarOpcaoControlaCentroCusto();

        // Controla Conta Comercial
         ParametroContabilEditarPage.SelecionarOpcaoContaComercial();

        //Utiliza Custo do Estoque na Contabilização
         ParametroContabilEditarPage.SelecionarOpcaoCustoEstoqueContabilizacao();

        //Sugere Rateio em Lançamentos Manuais
        ParametroContabilEditarPage.SelecionarOpcaoRateioLacamentosManuais();

        //Utiliza Saldo Societário
         ParametroContabilEditarPage.SelecionarOpcaoUtilizaSadoSocietario();

        //Permite Lançamentos de DB e CR na mesma Conta
         ParametroContabilEditarPage.SelecionarOpcaoLancamentosDBCRConta();

        //Consiste a Consolidação de Vendas (VND) de acordo com Período de Integração do DFS
         ParametroContabilEditarPage.SelecionarOpcaoConsolidacaoVendasDFS();

        //Utiliza Conta "Despesa Tributária" para a partida de Diferencial de Alíquota
          ParametroContabilEditarPage.SelecionarOpcaoUtilizaDespesaTributaria();

        //Prioriza o Centro de Custo do Setor nas Retiradas de Estoque
          ParametroContabilEditarPage.SelecionarOpcaoPriorizaCentroCustoRetiradaEstoque();

        //Considera Data da Movimentação na Contabilização das Retiradas
         ParametroContabilEditarPage.SelecionarOpcaoDataMovimentacaoContabilizacaoRetiradas();

        //Contabilidade por Lote Sintética na Integração com Conciliador
         ParametroContabilEditarPage.SelecionarOpcaoContabilidadeLoteSintetica();

        //Gera estorno de lançamento contábil
          ParametroContabilEditarPage.SelecionarOpcaoGeraEstornoLancamentoContabil();


        //Clicar no Botão Salvar
         ParametroContabilEditarPage.ClicarEmSalvar();

        //Clicar em Ok. Registro Salvo com Sucesso
         ParametroContabilEditarPage.ClicarOk();

    }
}